// Por Enrique Guerra (Quique)
// quique@quiquesoft.com
// 18 de agosto de 2000

#include "fivewin.ch"
#include "tArray.ch"

proc main
local oWnd,oMenu,oBrw,oArray

define struct oArray
   struct field especie
   struct field color
   struct field edad
   struct field hijos
      define struct
         struct field color
         struct field edad
      end struct
end struct

oArray:especie := "conejo "
oArray:color   := "blanco"
oArray:edad    := 4
oArray:hijos:color := "caf  "
oArray:hijos:edad  := 2
oArray:hijos:add()
oArray:hijos:color := "negro "
oArray:hijos:edad  := 1
oArray:hijos:add()
oArray:add()

// NOTA: para aumentar un nuevo registro en registros que tienen objetos o matrices
//       se tienen que aumentar con append, no con add, o hacer blank si se quiere
//       utilizar el add, porque si no, sigue guardando la referencia del anterior,
//       en los demas casos, puede seguirse aumentando con add() de la forma normal
oArray:append()
oArray:especie := "caballo"
oArray:color   := "pinto "
oArray:edad    := 6
oArray:hijos:color := "gris  "
oArray:hijos:edad  := 2
oArray:hijos:add()
oArray:save()

oArray:blank()
oArray:especie := "perro  "
oArray:color   := "canela"
oArray:edad    := 8
oArray:hijos:color := "blanco"
oArray:hijos:edad  := 4
oArray:hijos:add()
oArray:hijos:color := "pinto "
oArray:hijos:edad  := 3
oArray:hijos:add()
oArray:add()

MENU oMenu
   MENUITEM "&Ordenar por"
      MENU
         MENUITEM "&Especie" ACTION oArray:sort("especie"),oBrw:refresh()
         MENUITEM "&Color"   ACTION oArray:sort("color"),oBrw:refresh()
         MENUITEM "E&dad"    ACTION oArray:sort("edad"),oBrw:refresh()
      ENDMENU
   MENUITEM "&Buscar por"
      MENU
         MENUITEM "&Especie" ACTION buscar(oArray,oBrw,"especie"),oBrw:refresh()
         MENUITEM "&Color"   ACTION buscar(oArray,oBrw,"color"),oBrw:refresh()
         MENUITEM "&Edad"    ACTION buscar(oArray,oBrw,"edad"),oBrw:refresh()
      ENDMENU
   MENUITEM "&Ver los hijos" ACTION hijos(oArray)
   menuitem "&Recorrer registro" action oArray:aEval({|x,y|msgInfo(x,oArray:fieldName(y))})
   menuitem "R&ecorrer base"
      MENU
         MENUITEM "&Especie" ACTION oArray:dbEval({||msgInfo(oArray:especie,str(oArray:recNo()))})
         MENUITEM "&Color"   ACTION oArray:dbEval({|self|msgInfo(self:color  ,str(self:recNo()))})
         MENUITEM "&Edad"    ACTION oArray:dbEval({|self|msgInfo(self:edad   ,str(self:recNo()))})
      ENDMENU
   MENUITEM "&Salir"         ACTION oWnd:end()
ENDMENU

oArray:gotop()
define window oWnd menu oMenu
@0,0 listbox oBrw fields "" head "Especie","Color","Edad" sizes 100,100,100
oBrw:setArray(oArray:aDatos)
oBrw:bLine:={||{oArray:especie,oArray:color,str(oArray:edad)}}
oBrw:bSkip:={|nSkip|oArray:skip(nSkip)}
oWnd:oClient:=oBrw
activate window oWnd

proc buscar(oArray,oBrw,campo)
local xVar:=oSend(oArray,campo)
if msgGet( "Buscar por", campo, @xVar )
   if oArray:seek(xVar,campo)
      msgInfo("Encontrado")
   else
      oArray:goBottom()
      oBrw:nAt:=oArray:recNo()
      msgInfo("No encontrado")
   endIf
endIf

proc hijos(oArray)
local oDlg,oBrw,oHijos:=oArray:hijos
oHijos:gotop()
define dialog oDlg from 0,0 to 15,30
@.5,.5 listbox oBrw fields "" head "Color","Edad" sizes 100,100
oBrw:setArray(oHijos:aDatos)
oBrw:bLine:={||{oHijos:color,str(oHijos:edad)}}
oBrw:bSkip:={|nSkip|oHijos:skip(nSkip)}
activate dialog oDlg center