#include "FiveWin.ch"
#include "wcolors.ch"

////////////////////////////////////////////////////////////////////////////////
// Bienvenidos al Sample06 de Seleccion TWBrowse Multiple.
// Esta Clase, setea atributos y bloques de codigo de la clase TWBrowse, y
// juntas emulan la seleccion multiple como en ListBox de Arrays. Pero ahora
// lo podremos hacer con bases de datos.
// La tecla ESPACIO selecciona y deselecciona la opcion, al igual que los clicks
// del Mouse. Ejemplo simple de como usar la clase TMultiSel.
////////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------//
Function Main()
 LOCAL oDlg, oLbx
 LOCAL oFont, oMultiSel

    USE Equipos ALIAS Datos

    DEFINE FONT oFont NAME 'MS Sans Serif' SIZE 0,-8

    DEFINE DIALOG oDlg FROM 0,0 TO 15,45               ;
                  TITLE "TWBrowse + TMultiSel Engine" ;
                  FONT oFont
       oDlg:nStyle:= nOr( oDlg:nStyle, 4 ) // Pongo 3D Nativo


       @00,03 SAY 'Futbol Argentino' OF oDlg

       @01,01 LISTBOX oLbx ;
                      FIELDS DATOS->Equipo ;
                      HEADERS "","" SIZE 85,90 OF oDlg

       oMultiSel:= TMultiSel():New( oLbx )

       @20,100 BUTTON "Select &All" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION oMultiSel:SelectAll()

       @40,100 BUTTON "UnSelect &All" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION oMultiSel:UnSelectAll()

       @60,100 BUTTON "&Reverse" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION oMultiSel:Reverse()

       @90,100 BUTTON "&Ver Seleccion" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION VerSeleccion( oMultiSel )


    ACTIVATE DIALOG oDlg CENTERED


return Nil

//----------------------------------------------------------------------------//
STATIC Function VerSeleccion( oMultiSel )
 LOCAL cMsg:= "Estan seleccionados todos los registros"
 LOCAL nLen:= Len( oMultiSel:aRecNo )
 LOCAL cLen:= " ( " + AllTrim(Str(nLen)) + " son )"

    If oMultiSel:lSelectAll
       If nLen == 0
          cMsg+= "."
       Else
          cMsg+= CRLF + "MENOS los de la matriz oMultiSel:aRecNo." +cLen
       EndIf
    Else
       If nLen == 0
          cMsg:= "NO HAY registros seleccionados."
       Else
          cMsg+= " de la matriz oMultiSel:aRecNo." + cLen
       EndIf
    EndIf

    MsgAlert( cMsg )

    MemoSeleccion( oMultiSel )

return Nil

//----------------------------------------------------------------------------//
STATIC Function MemoSeleccion( oMultiSel )
 LOCAL cMemo:= 'Estos son los Items Seleccionados:' + CRLF +;
               '==================================' + CRLF + CRLF
 LOCAL nLen:= Len( cMemo ), lHeader:= .f.
 LOCAL nRecNo:= RecNo()

    DbGoTop()
    While !Eof()

       If oMultiSel:IsSelect( RecNo() )
          If !lHeader
             cMemo+= "RecNo()     Equipo" + CRLF + ;
                     "======= ====================================" + CRLF
             lHeader:= .t.
          EndIf
          cMemo+= StrZero(RecNo(),7) + "  "+ Field->Equipo + CRLF
       EndIf

       DbSkip()

    EndDo

    If Len( cMemo ) == nLen
       cMemo+= "NO HAY ITEMS SELECCIONADOS !!!!" + CRLF
    EndIf

    DbGoto( nRecNo )

    MemoEdit( cMemo )

return Nil

//----------------------------------------------------------------------------//
