#include "FiveWin.ch"
#include "wcolors.ch"

////////////////////////////////////////////////////////////////////////////////
// Bienvenidos al Sample07 de Seleccion TWBrowse Multiple.
// Veremos un ejemplo un poco mas complejo, con el uso de BitMaps.
////////////////////////////////////////////////////////////////////////////////

#define ENTERPRISE

//----------------------------------------------------------------------------//
Function Main()
 LOCAL oDlg, oLbx
 LOCAL oFont, oMultiSel, oBmpOn, oBmpOff

    USE Equipos ALIAS Datos

    DEFINE BITMAP oBmpOn  FILE "checkon.bmp"
    DEFINE BITMAP oBmpOff FILE "checkoff.bmp"

    DEFINE FONT oFont NAME 'MS Sans Serif' SIZE 0,-8

    DEFINE DIALOG oDlg FROM 0,0 TO 15,45               ;
                  TITLE "TWBrowse + TMultiSel Engine" ;
                  FONT oFont
       oDlg:nStyle:= nOr( oDlg:nStyle, 4 ) // Pongo 3D Nativo


       @00,03 SAY 'Futbol Argentino' OF oDlg

       #ifdef ENTERPRISE
         TWBrowse():lHScroll:= .f. // Sin Scroll Horizontal para la variable
       #endif                      // de la clase.

       @01,01 LISTBOX oLbx ;
                      FIELDS If( oMultiSel:lSelect, oBmpOn, oBmpOff ):hBitmap,;
                             DATOS->Equipo ;
                      HEADERS "","" SIZE 95,87 OF oDlg

       oMultiSel:= TMultiSel():New( oLbx )

       @20,110 BUTTON "Select &All" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION oMultiSel:SelectAll()

       @40,110 BUTTON "UnSelect &All" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION oMultiSel:UnSelectAll()

       @60,110 BUTTON "&Reverse" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION oMultiSel:Reverse()

       @90,110 BUTTON "&Ver Seleccion" OF oDlg SIZE 40,Nil PIXEL ;
               ACTION VerSeleccion( oMultiSel )


    ACTIVATE DIALOG oDlg CENTERED

    RELEASE BITMAP oBmpOn, oBmpOff
    RELEASE FONT oFont
return Nil

//----------------------------------------------------------------------------//
STATIC Function VerSeleccion( oMultiSel )
 LOCAL cMsg:= "Estan seleccionados todos los registros"
 LOCAL nLen:= Len( oMultiSel:aRecNo )
 LOCAL cLen:= " ( " + AllTrim(Str(nLen)) + " son )"

    If oMultiSel:lSelectAll
       If nLen == 0
          cMsg+= "."
       Else
          cMsg+= CRLF + "MENOS los de la matriz oMultiSel:aRecNo." +cLen
       EndIf
    Else
       If nLen == 0
          cMsg:= "NO HAY registros seleccionados."
       Else
          cMsg+= " de la matriz oMultiSel:aRecNo." + cLen
       EndIf
    EndIf

    MsgAlert( cMsg )

    MemoSeleccion( oMultiSel )

return Nil

//----------------------------------------------------------------------------//
STATIC Function MemoSeleccion( oMultiSel )
 LOCAL cMemo:= 'Estos son los Items Seleccionados:' + CRLF +;
               '==================================' + CRLF + CRLF
 LOCAL nLen:= Len( cMemo ), lHeader:= .f.
 LOCAL nRecNo:= RecNo()

    DbGoTop()
    While !Eof()

       If oMultiSel:IsSelect( RecNo() )
          If !lHeader
             cMemo+= "RecNo()     Equipo" + CRLF + ;
                     "======= ====================================" + CRLF
             lHeader:= .t.
          EndIf
          cMemo+= StrZero(RecNo(),7) + "  "+ Field->Equipo + CRLF
       EndIf

       DbSkip()

    EndDo

    If Len( cMemo ) == nLen
       cMemo+= "NO HAY ITEMS SELECCIONADOS !!!!" + CRLF
    EndIf

    DbGoto( nRecNo )

    MemoEdit( cMemo )

return Nil

//----------------------------------------------------------------------------//
