#INCLUDE 'FIVEWIN.CH'
#INCLUDE 'OBJECTS.CH'
#INCLUDE "REPORT.CH"   // Reportes Fivewin


#DEFINE NSALTOREN    00.30   // Salto de renglon
#DEFINE NSRENNEG     00.05   // Salto de encabezados
#DEFINE NSTITNEG     NSALTOREN + NSRENNEG + 0.05 // Salto de Renglon de Titulos en Negritas
#DEFINE NMAXPAGINA   24.00   // Numero Maximo de Cm en la pagina antes de terminar (Renglones)
#DEFINE NMINLINEA    00.90   // Numero de Inicio de la Linea (Columnas)
#DEFINE NMAXLINEA    20.10   // Numero de Fin de la linea  (Columnas)
#DEFINE MERGEPAINT   12255782 // 0xBB0226
#DEFINE SRCAND       8913094

#define PAD_LEFT        0
#define PAD_RIGHT       1
#define PAD_CENTER      2

STATIC oPrinter

*SET PROCEDURE TO '.\PRINTER\PRINTER.PRG'  // ESTE PRG. CONTIENE FUNCIONES CREAR EMF'S EN LAS IMPRESIONES
*SET PROCEDURE TO '.\PRINTER\RPREVIEW.PRG' // ESTE PRG. CONTIENE FUNCIONES CREAR EMF'S EN LAS IMPRESIONES
*SET PROCEDURE TO '.\PRINTER\TMETAFIL.PRG' // ESTE PRG. CONTIENE FUNCIONES CREAR EMF'S EN LAS IMPRESIONES


// Clase Hija que se deriva de TPrinter y que aado las funciones propias de servicrece
// Hechas por Memo Parra y Por Luis Fernando Rubio Rubio
// Ultima Modificacion: 29/06/02 11:49AM
CLASS TCustomImpresion FROM TPrinter
  DATA oBrush, oPen      AS OBJECT INIT NIL
  DATA fBold, fNormal, fTitulo, fGeneral, fBarra    AS OBJECT INIT NIL

  DATA xCor      AS ARRAY INIT {}
  DATA yCor      AS ARRAY INIT {}

  DATA nLinI     AS NUMERIC INIT 00.90
  DATA nLinF     AS NUMERIC INIT 27.04
  DATA nColI     AS NUMERIC INIT 00.90
  DATA nColF     AS NUMERIC INIT 20.39

  DATA nLinea    AS NUMERIC INIT 01.00
  DATA nCol      AS NUMERIC INIT 01.00

  METHOD Linea( pnArriba, pnIzq, pnAbajo, pnDerecha )
  METHOD Caja( pnArriba, pnIzq, pnAbajo, pnDerecha, pnTipo, poBrush, poPen )
  METHOD Bitmap( nArriba, nIzq, nAncho, nAlto, xBitmap )
  METHOD CentraCadenas( pnRenglon, pnColIni, pnColFin, pcDato, poFuente )
  METHOD ImprNumeros( pcDato, pcDatoIni, pcDatoFin, pcMascara, pnRenglon, pnColIni, pnColFin, poFuente )
  METHOD ImprCadenaJust( pcDato, pnRenglon, pnColIni, pnColFin, poFuente, pnMaxRen, plIncrementa, plCentra )
  METHOD xPadMemoR( pcText, pnPixels, pcChar, poFuente )
  METHOD xPadMemoL( pcText, pnPixels, pcChar, poFuente )
  METHOD xPadMemoC( pcText, pnPixels, pcChar, poFuente )
  METHOD BoxPipu( pnRenIzq, pnColIzq, pnRenDer, pnColDer, poPen)
  METHOD TextoNumero( pnRenglon, pnColTexto, pnColNumIni, pnColNumFin, pcTexto, pnNumero, pcFormato, poFntText, poFntNumero )
  METHOD TextoTexto( pnRenglon, pnMinColT1, pnMinColT2, pnMaxColTexto2, pcTexto1, pcTexto2, plLinea, poFuente1, poFuente2 )
  METHOD f_Impr_Encabezado( pcReporte, pcRango, pcTitulo )
  METHOD f_Impr_PiePagina()
  METHOD f_ChecaLinea( pcReporte, pcRango )
  *METHOD f_CodBar( pnRow, pnCol, pcTipo, pcTexto )
ENDCLASS

/*METHOD f_CodBar( nRow, nCol, pcTipo, pcTexto ) CLASS TCustomImpresion
  ::Cmtr2Pix(@pnRow, @pnCol)
  do case
    case pcTipo$"CODE128"
      @ pnRow, pnCol code128 pcTexto OF oPrinter
  endcase
  ::Say( nRow, nCol, cText, oFont, nWidth, nClrText, nBkMode, nPad )
RETURN(SELF)*/

METHOD f_Impr_Encabezado( pcReporte, pcRango, pcTitulo ) CLASS TCustomImpresion
  default pcReporte := "reporte x", pcRango := "", pcTitulo := oApp:cEmpresa

  ::BoxPipu( ::nLinI, ::nColI, ::nLinF, ::nColF, ::oPen  )
  ::SayBitmap( 50.00, 100.00, ".\bitmaps\logo_impresion.bmp", 400, 400 )
  ::cmSay( 01.50, 01.00, time(),                             ::fGeneral,, CLR_BLACK,, PAD_LEFT   )
  ::cmSay( 01.00, 10.50, pcTitulo,                           ::fTitulo,,  CLR_RED  ,, PAD_CENTER )
  ::cmSay( 01.00, 20.00, FechaCompleta(date()),              ::fGeneral,, CLR_BLACK,, PAD_RIGHT  )
  ::cmSay( 01.50, 20.00, "Pagina: " + strzero( ::nPage, 3 ), ::fGeneral,, CLR_BLACK,, PAD_RIGHT  )
  ::cmSay( 01.60, 10.50, pcReporte,                          ::fTitulo,,  CLR_RED  ,, PAD_CENTER )
  ::cmSay( 02.30, 10.50, pcRango,                            ::fBold,,    CLR_GRAY ,, PAD_CENTER )
  ::Linea( 02.60, 00.90, 02.60, 20.39 )
return( SELF )

METHOD f_Impr_PiePagina() CLASS TCustomImpresion
  ::Linea( 26.50, 00.90, 26.50, 20.39 )
  ::cmSay( 26.50, 01.00, "Inferior Izquierda",               ::fGeneral,, CLR_BLACK,, PAD_LEFT   )
  ::cmSay( 26.50, 10.50, "Pagina: " + strzero( ::nPage, 3 ), ::fGeneral,, CLR_BLACK,, PAD_CENTER )
  ::cmSay( 26.50, 20.00, "Inferior Derecha",                 ::fGeneral,, CLR_BLACK,, PAD_RIGHT  )
return( SELF )

METHOD f_ChecaLinea( pcReporte, pcRango ) CLASS TCustomImpresion
  local lHojaNueva := .F.

  if ::nLinea >= 26.60
    *ENDPAGE
    *PAGE
    MyPageEnd()
    MyPageBegin()
    ::f_Impr_Encabezado( pcReporte, pcRango )
    ::nLinea := 02.80
    lHojaNueva := .T.
  endif
return( lHojaNueva )


// Funcion que dibuja una linea segun las coordenadas que le demos
// Parametros: pnArriba, pnIzq, pnAbajo, pnDerecha: Coordenadas en Centimetros
METHOD Linea( pnArriba, pnIzq, pnAbajo, pnDerecha ) CLASS TCustomImpresion
  LOCAL xCor := {} , yCor := {}

  xCor := ::Cmtr2Pix( pnArriba, pnIzq )
  yCor := ::Cmtr2Pix( pnAbajo, pnDerecha )
  ::Line( xCor[1], xCor[2], yCor[1], yCor[2], ::oPen)
RETURN( SELF )

// Funcion que dibuja una caja segun las coordenadas que le demos
// Parametros: pnArriba, pnIzq, pnAbajo, pnDerecha: Coordenadas en Centimetros
//             pnTipo:  Tipo de Caja
//             poBrush: Objeto del Brush
//             poPen:   Objeto del Pen
METHOD Caja( pnArriba, pnIzq, pnAbajo, pnDerecha, pnTipo, poBrush, poPen ) CLASS TCustomImpresion
  Local xCor := {} , yCor := {}
  DEFAULT poBrush := ::oBrush, poPen := ::oPen

  // Pasamos coordenadas de cms a pixel
  xCor := ::Cmtr2Pix( pnArriba, pnIzq )
  yCor := ::Cmtr2Pix( pnAbajo, pnDerecha )
  DO CASE
    CASE pnTipo == 0       // Caja Vacia
      // Demostrando RoundRect en la Impresora
      //CajaRound(oPrn,xCor[1],xCor[2],yCor[1],yCor[2],50,50)
      //::FillRect( { xCor[1], xCor[2], yCor[1], yCor[2] }, poBrush )
      Roundrect(::hdcOut, xCor[2], xCor[1], yCor[2], yCor[1], 70, 70)
    CASE pnTipo == 1       // Caja rellena
      ::FillRect( { xCor[1], xCor[2], yCor[1], yCor[2] }, poBrush )
    CASE pnTipo == 2       // Caja Normal
      ::Box( xCor[1], xCor[2], yCor[1], yCor[2], poPen)
    CASE pnTipo == 3       // Caja Normal y Rellena
      ::Box( xCor[1], xCor[2], yCor[1], yCor[2], poPen)
      ::FillRect( { xCor[1], xCor[2], yCor[1], yCor[2] }, poBrush )
      //Roundrect(::hdcOut,xCor[2],xCor[1],yCor[2],yCor[1], 50, 50)
    CASE pnTipo == 4
      ::BoxPipu( pnArriba, pnIzq, pnAbajo, pnDerecha )
      ::BoxPipu( pnArriba + 00.05, pnIzq + 00.05, pnAbajo - 00.05, pnDerecha - 00.05 )
  ENDCASE
RETURN( SELF )

// Funcion que dibuja un bitmap segun las coordenadas y el tamao que le especifiquemos
// Parametros pnArriba, nIzq: Coordenadas en Centimetros
//            pnAncho:  Ancho del Bitmap expresados en cms
//            pnAlto:   Alto del Bitmap Expresados en cms
//            pxBitmap: Archivo BMP

METHOD Bitmap(nArriba,nIzq,nAncho,nAlto,xBitmap) CLASS TCustomImpresion
  *LOCAL xCor := {}
  LOCAL nPixWidth, nPixHeight
  DEFAULT nAncho := NIL, nAlto := NIL

  *::xCor := ::Cmtr2Pix(nArriba,nIzq)
  nAncho := nAncho / 02.54
  nAlto  := nAlto  / 02.54
  nPixWidth  := INT(::nLogPixelY()*nAncho)
  nPixHeight := INT(::nLogPixelX()*nAlto)
  ::SayBitmap(::xCor[1], ::xCor[2], xBitmap, nPixWidth, nPixHeight)
RETURN( SELF )



// Funcion que centra cadenas dentro de un Rango especifico
// Parametros: pnRenglon: Renglon donde se imprimira la cadena
//             pnColIni:  Columna Inicial
//             pnColFin:  Columna Final
//             pcDato:    Cadena a Imprimir
//             poFuente:  Fuente con la que se imprimira la cadena
METHOD CentraCadenas( pnRenglon, pnColIni, pnColFin, pcDato, poFuente ) CLASS TCustomImpresion
  Local  yCor:={}, xCor:={}
  local cCadena := ''

  xCor := ::Cmtr2Pix( pnRenglon, pnColIni )
  yCor := ::Cmtr2Pix( pnRenglon, pnColFin )
  cCadena := ::xPadMemoC( pcDato, yCor[2] - xCor[2], ' ', poFuente )
  ::cmSay( pnRenglon, pnColIni, cCadena, poFuente ) // Espacio en Blanco
RETURN( SELF )

// Funcion para imprimir numeros alineados
// Parametros: pDato:     Numeros a Imprimir
//             pcDatoIni: Cadena que se imprimira antes de los numeros
//             pcDatoFin: Cadena que se imprimira despues de los numeros
//             pcMascara: Mascara para la impresin de los numeros
//             pRenglon:  Renglon donde se imprimira los numeros
//             pnColIni:   Columna Inicial
//             pnColFin:   Columna Final
//             poFuente:   Fuente con la que se imprimiran los numeros
METHOD ImprNumeros( pcDato, pcDatoIni, pcDatoFin, pcMascara, pnRenglon, pnColIni, pnColFin, poFuente) CLASS TCustomImpresion
  Local  yCor:={}, xCor:={}
  local cNumero := ''
  DEFAULT pcDatoIni := '', pcDatoFin := ''

  xCor := ::Cmtr2Pix( pnRenglon, pnColIni )
  yCor := ::Cmtr2Pix( pnRenglon, pnColFin )
  cNumero := ::xPadMemoL( ALLTRIM( TRANSFORM( pcDato, pcMascara ) ), yCor[2] - xCor[2],' ', poFuente)
  ::cmSay( pnRenglon, pnColIni, pcDatoIni + cNumero + pcDatoFin, poFuente)
RETURN( SELF )


// Funcion para imprimir cadenas en un rango de Columnas sin pasarse
// Parametros: pcDato: Cadena a Imprimir
//             pnRenglon: Renglon a Imprimir
//             pnColIni: Columna Inicial
//             pnColFin: Columna Final
//             poFuente: Fuente para Imprimir
//             pnMaxRen: Numero Maximo de Renglones
//             plIncrementa:
//             plCentra:
 METHOD ImprCadenaJust( pcDato, pnRenglon, pnColIni, pnColFin, poFuente, pnMaxRen, plIncrementa, plCentra ) CLASS TCustomImpresion
   Local  yCor:={}, xCor:={}
   local cParteCadena := '', i:=0
   Local numMaxRenglones := iif(pcount() < 7,1000,pnMaxRen)
   Local lIncrementa:= iif(pcount() < 8,.t.,plIncrementa)

   DEFAULT plCentra := .f.

   ::xCor := ::Cmtr2Pix(pnRenglon,pnColIni)
   ::yCor := ::Cmtr2Pix(pnRenglon,(pnColFin))

   i := 0
   Do While !Empty(pcDato) // Mientras no este vacia la variable
      cParteCadena := ::xPadMemoR(pcDato, yCor[2] - xCor[2]," ",poFuente)
      pcDato:=right(pcDato,len(pcDato)-len(cParteCadena))
      If right(cParteCadena,1) =''
        cParteCadena = left(cParteCadena,len(cParteCadena)-1)
      EndIf

      if plCentra
        ::CentraCadenas( pnRenglon += iif(i=0 .or. ! lIncrementa, 0, 00.30 ), pnColIni, pnColFin, cParteCadena,poFuente)
      else
        ::cmSay(pnRenglon+=IIF(i=0 .or. !LIncrementa,0,00.30),pnColIni,cParteCadena,poFuente) // Espacio en Blanco
      endif

      i++
      If numMaxRenglones = i
        exit
      Endif
   EndDo
 RETURN( pcDato )

 // Funcion que Corrige algunos Bugs de la function xPadR() de FiveWin, por ende es parecida...
 // Memo Parra 08.09.2000
 // Modificacion Anterior: 08.09.2000 GPU
 // Ultima Modificacion: 08.09.2000 LFRR
 // Donde pcText    = Cadena de Texto a Imprimir
 //       pnPixeles = Total de Pixeles
 //       pcChar    = Default de Relleno
 //       pFuente   = Fuente a Imprimir
 METHOD xPadMemoR( pcText, pnPixels, pcChar, poFuente) CLASS TCustomImpresion
   Local CadFinal:='', Pos:=1,ultimaPos:=0
   DEFAULT pcChar := Chr(32)

   Do While ::GetTextWidth(cadFinal+substr(pcText,pos,1),poFuente ) < pnPixels // Mientras el Tamao en pixeles de Cadfinal sea < Total del Area de Pixeles
     cadFinal+=substr(pcText,pos,1)

     // Si al final de la cadena tenemos un ''
     If substr(pcText,pos,1) = ''
       exit // Porque Salir y no hacer una accion como cambiar de linea?
     EndIf

     pos++ // Incrementamos la posicion siguiente de la cadena

     // Si el Tamao de la cadena final es igual al de la cadena Inicial
     If len(cadFinal) = len(pcText)
       Exit
     EndIf
   EndDo
   UltimaPos := len(CadFinal)
   pos:=len(CadFinal)+1
   If len(CadFinal) != Len(pcText)
     Do While !(Substr(pcText,pos,1)$' ,;') .and. pos > 1      // pos > 0
       pos--
       CadFinal=left(pcText,pos)
     EndDo
     If pos = 1 //pos > 0
       cadFinal=substr(pcText,1,ultimaPos)
     EndIf
   EndIf
 RETURN( cadFinal )

// Guillermo Parra 09.2000
METHOD xPadMemoL( pcText, pnPixels, pcChar, poFuente ) CLASS TCustomImpresion
   DEFAULT pcChar := chr(32)

   while ::GetTextWidth( pcChar + pcText, poFuente) < pnPixels
      pcText = pcChar + pcText
   end
RETURN( pcText )

METHOD xPadMemoC( pcText, pnPixels, pcChar, poFuente ) CLASS TCustomImpresion

   local cRet    := If( ValType( pcText ) == "C", AllTrim( pcText ), "" )
   local nLen    := Len( pcText )
   local nPixLen := ::GetTextWidth(pcText,poFuente)
   local nPad    := ::GetTextWidth(pcChar,poFuente)

   If pnPixels > nPixLen
      cRet = PadC( cRet, nLen + ( pnPixels - nPixLen ) / nPad,pcChar)
   EndIf
RETURN( cRet )


 // Function para remplazar la funcion que habia de Cuadro...
 // 05.09.2000 LFRR
METHOD BoxPipu( pnRenIzq, pnColIzq, pnRenDer, pnColDer, poPen) CLASS TCustomImpresion
  DEFAULT poPen := ::oPen

  ::Linea(pnRenIzq,pnColIzq,pnRenIzq,pnColDer,poPen) // Linea Superior
  ::Linea(pnRenDer,pnColDer,pnRenIzq,pnColDer,poPen) // Linea Derecha
  ::Linea(pnRenDer,pnColDer,pnRenDer,pnColIzq,poPen) // Linea Inferior
  ::Linea(pnRenIzq,pnColIzq,pnRenDer,pnColIzq,poPen) // Linea Izquierda
RETURN( SELF ) //*****************************************************************************************************************//

// Metodo que imprime en linea un Texto y un valor numerico, con la opcion a seleccionar formato, etc, etc
METHOD TextoNumero( pnRenglon, pnColTexto, pnColNumIni, pnColNumFin, pcTexto, pnNumero, pcFormato, poFntText, poFntNumero, plLinea ) CLASS TCustomImpresion
  DEFAULT plLinea := .T.

  ::cmSay( pnRenglon, pnColTexto, pcTexto,poFntText)
  ::ImprNumeros( pnNumero,,,pcFormato, pnRenglon, pnColNumIni, pnColNumFin, poFntNumero )
  If plLinea
    ::Linea( pnRenglon+NSALTOREN, pnColNumIni, pnRenglon+NSALTOREN, pnColNumFin )
  EndIf
Return(SELF)

// Metodo que imprime en lina un Texto, una linea y otro texto
METHOD TextoTexto( pnRenglon, pnMinColT1, pnMinColT2, pnMaxColTexto2,;
                   pcTexto1, pcTexto2, plLinea, poFuente1, poFuente2, plCentrado ) CLASS TCustomImpresion
  DEFAULT plLinea := .T., plCentrado := .f.

  ::cmSay( pnRenglon, pnMinColT1, pcTexto1, poFuente1)
  If plCentrado
    ::CentraCadenas( pnRenglon, pnMinColT2, pnMaxColTexto2, pcTexto2, poFuente2 )
  else
    ::cmSay( pnRenglon, pnMinColT2, pcTexto2, poFuente2)
  endif
  If plLinea
    ::Linea( pnRenglon+NSALTOREN, pnMinColT2, pnRenglon+NSALTOREN, pnMaxColTexto2 )
  EndIf
RETURN(self)


FUNCTION MyPrintBegin( cDoc, lUser, lPreview, xModel, lModal, lSelection )

   local aPrn
   local cText, cDevice
   local nScan

   if xModel == NIL
      RETURN oPrinter := TCustomImpresion():New( cDoc, lUser, lPreview,, lModal, lSelection )
   endif

   cText := StrTran(GetProfString("Devices"),Chr(0), chr(13)+chr(10))
   aPrn  := Array(Mlcount(cText, 250))

   Aeval(aPrn, {|v,e| aPrn[e] := Trim(Memoline(cText, 250, e)) } )

   if Valtype(xModel) == "N"
      if xModel < 0 .or. xModel > len(aPrn)
         nScan := 0
      else
         nScan := xModel
      endif
   else
      nScan := Ascan(aPrn, {|v| Upper(xModel)$Upper(v) })
   endif

   if nScan == 0
      msgBeep()
      RETURN oPrinter := TCustomImpresion():New( cDoc, .T., lPreview,, lModal, lSelection )
   endif

   cText   := GetProfString("Devices", aPrn[nScan])
   cDevice := aPrn[nScan]+","+cText

RETURN oPrinter := TCustomImpresion():New( cDoc, .f., lPreview, cDevice, lModal, lSelection )

FUNCTION MyPageBegin() ; oPrinter:StartPage() ; RETURN ( NIL )

//----------------------------------------------------------------------------//

FUNCTION MyPageEnd() ; oPrinter:EndPage(); RETURN ( NIL )

//----------------------------------------------------------------------------//

FUNCTION MyPrintEnd()

     IF oPrinter:lMeta
          oPrinter:Preview()
     ELSE
          oPrinter:End()
     ENDIF
     oPrinter := nil

RETURN ( NIL )

Function LinBox( poReport )
  LOCAL nInchWidth, nInchHeight

  nInchWidth  := poReport:PhyWidth(RPT_INCHES)
  nInchHeight := poReport:PhyHeight(RPT_INCHES)
  poReport:Box( 00.10, 00.10, nInchHeight - 00.10, nInchWidth - 00.10, 1, RPT_INCHES )
RETURN ( NIL )


// Llamada al Api de Windows..----------------------------------------------
 DLL FUNCTION RoundRect( hDC AS WORD, iLeft AS _INT , iTop AS _INT, iRight AS _INT, iBottom AS _INT, ;
                         iWidth AS _INT, iHeight AS _INT ) AS BOOL PASCAL LIB "GDI.EXE"


