// --------------------------------------------------------------------------------------------------------
// Programador: Luis Fernando Rubio Rubio
// Empresa:
// Lenguaje de Desarrollo: Fivewin for (x)Harbour 2.7 December 2005, xHarbour Build 0.99.51 Intl (Simplex)
// Nombre: INDEXAR.PRG
// Comentarios: Modulo de Mantenimiento de las bases de datos

// --------------------------------------------------------------------------------------------------------
// Historial de Actualizaciones
// --------------------------------------------------------------------------------------------------------
//f_Indexar( "desa",     { { "nume", "nume" },;
//                         { "desc", "desc" } },,xDir )

#include "fivewin.ch"

function f_Indexar( pcBaseDatos, paDatos, plCatalogo, pcRuta )
  local x := 0
  local bSentencia := { | oMeter, oText, oDlg, lEnd | BuildIndex( oMeter, oText, oDlg, @lEnd, paDatos[x,1], paDatos[x,2] ) }
  local cAlias     := cFileNoExt(pcBaseDatos)

  default plCatalogo := .F., pcRuta := ".\"

  if ! plCatalogo
    FErase( pcruta + cFileNoExt(pcBaseDatos) + ".cdx" )

    if ! net_use( pcBaseDatos, .T., cAlias, pcRuta )
      dbCloseAll(); return(nil)
    endif

    if (cAlias)->(fLock())
      (cAlias)->(dbPack()); (cAlias)->(dbUnlock())
    endif
  endif

  for x := 1 to len(paDatos)
    MsgProgress( bSentencia, "INDEXANDO: " + upper(alltrim(pcRuta + pcBaseDatos)) + if( empty( cFileExt( pcBaseDatos ) ), ".DBF", "" ) + " EN: " + alltrim(paDatos[x,2]) + " CON LLAVE: " + alltrim(paDatos[x,1])  )
  next

  if ! plCatalogo
    (cAlias)->(dbCloseArea())
  else
    MsgAlert( "El mantenimiento a: " + NomCatalogos(upper(pcBaseDatos)) + CRLF + " En: " + lower(pcRuta + pcBaseDatos) + if( empty( cFileExt( pcBaseDatos ) ), ".dbf", "" ) + ", se finalizo satisfactoriamente...", oApp:cEmpresa )
  endif
return(nil)

function MsgProgress( bAction, cMsg, cTitle )
   local oDlg, oMeter, oText, oBtn, oFont
   local lEnd := .f., lCancel := .f.
   local nVal := 0

   DEFAULT bAction := { || nil },;
           cMsg := "Procesando...", cTitle := "Espere por favor..."

   DEFINE DIALOG oDlg FROM 5, 5 TO 14, 45 TITLE oApp:cEmpresa FONT oApp:fNormal
    @ 0.2, 0.5  SAY oText VAR cMsg SIZE 130, 30 OF oDlg
    oMeter = TProgress():New( 02.00, 01.00,,,,,,,150 )

    @  03.00,  10.4  BUTTON oBtn PROMPT "&Cancelar" OF oDlg ACTION ( lEnd:= .t., lCancel:= .t. ) SIZE 32, 11
    oBtn:cToolTip := "Presione para Cancelar"
    // This block gets evaluated only the first time the DialogBox is painted !!!
    oDlg:bStart = { || Eval( bAction, oMeter, oText, oDlg, @lEnd, oBtn ), lEnd := .t., oDlg:End() }
   ACTIVATE DIALOG oDlg CENTERED VALID lEnd
return lCancel

// es parte escencial de reord
function BuildIndex( poMeter, poText, poDlg, plEnd , pcCampo, pcBolsa)
  Local nContador := 0, nTotal := 0
  Local cBaseDatos := alias()

  nTotal := (cBaseDatos)->(LastRec())

  poMeter:SetRange(0, nTotal)
  *poText:SetText("Indexando: " + pcCampo + " con el indice: " + pcBolsa)
  (cBaseDatos)->(OrdSetFocus(0))
  INDEX ON &(pcCampo)  ;
        TAG &(pcBolsa) ;
        EVAL ( poMeter:SetPos( (cBaseDatos)->(recno()) ), SysRefresh(), ! plEnd )
        // EVAL { f_AvanceIndex( poMeter, nTotal ) }
  poMeter:SetPos( nTotal )
return ( nil )

function f_AvanceIndex( poMeter, pnTotal )
  local nRegProc := 0, nAvance := 0

  nRegProc += 10
  nAvance := ( nRegProc / pnTotal ) * 100
  poMeter:SetPos( nAvance )
  *sysrefresh()
return(nil)
