#include "fivewin.ch"

// Determinar si existe el campo en el area indicada
// Manuel Rafael Morfin Nieto 1998
function ExisteCampo( pCampo)
  local i:=0, mArea:=0, lExiste := .F.

  for i=1 to fcount()
    if upper(fieldname(i)) == upper(pCampo)
      lExiste := .T.
    endif
  next

return(lExiste)

// funcion para establecer los tipos de letra en los footers, headers y celdas del TWBROWSE
// Tomado del foro de FW, LFRR
Function SeleccionaFuente( nRow, nCol, nStyleLine, tFont0, tFont1, tFont2, tFont3 )
  LOCAL hFont := nil

  IF       nStyleLine == 0 ; hFont := tFont0:hFont  // 0 -> Celda standard normal
    ElseIf nStyleLine == 1 ; hFont := tFont1:hFont  // 1 -> Celda Header
    ElseIf nStyleLine == 2 ; hFont := tFont2:hFont  // 2 -> Celda Footer
    ELseIf nStyleLine == 3 ; hFont := tFont3:hFont  // 3 -> Celda standard normal seleccionada
  EndIf
Return( hFont )

// hace el efecto del click en el header del TWBrowse y hace el cambio de indice segun el Header
// LFRR
function f_CambiarIndice( pcBaseDatos, pcIndice, pnColumna, poBrowse, poDlg )
  (pcBaseDatos)->(OrdSetFocus( pnColumna ))

  with object poBrowse
    :bBkColor      := {|nRow,nCol,nStyle| IF( nStyle == 1, IF( nCol == pnColumna, nRGB(128,0,64), ), ) }
    :bTextColor    := {|nRow,nCol,nStyle| IF( nStyle == 1, IF( nCol == pnColumna, CLR_WHITE, ), ) }

    for x := 1 to len( :aHeaders )
      :aHeaders[ x ] := lower( :aHeaders[ x ] )
    next

    :aHeaders[ pnColumna ] := upper( poBrowse:aHeaders[ pnColumna ] )
    :cBuffer       := ""

  end with
  poDlg:cTitle := "Listado de: " + NomCatalogos(pcBaseDatos) + ": Ordenando por: " + pcIndice
  (pcBaseDatos)->(dbGotop())
return(nil)


// Funcion que incrementa automaticamente el numero consecutivo del contador en los registros
// pero en bases de datos LFRR
function IncDb(pcBaseDatos)
  local nTamano := len( (pcBaseDatos)->(fieldget( 1 ) ) )
  Local cId := space(nTamano)

  select(pcBaseDatos)
  (pcBaseDatos)->(OrdSetFocus(1))
  (pcBasedatos)->(dbGoBottom())
  cId := alltrim( strzero( val( (pcBaseDatos)->(fieldget( 1 ) ) ) + 1, nTamano ) )
return(cId)

// Funcion para validar que no se repita el numero de ID, para bases de datos
function ValIdDb(pcBaseDatos, cId, pnOperacion)
  Local lContinuar := .F., nRecno := (pcbasedatos)->(recno())

  if pnOperacion = 1 .and. (pcBaseDatos)->(dbSeek(cId))
    MsgStop("Imposible duplicar codigo, verifique o cambie...", oApp:cEmpresa )
  else
    lContinuar := .T.
  endif

  if pnOperacion <> 1
    (pcBaseDatos)->(dbgoto(nRecno))
  endif

Return(lContinuar)

// sirve para agregar registros a una base de datos
// funcion publica pero con adecuaciones propias.
FUNCTION add_rec( pnSegundos )
  local nSegundos := 0, lExito := .F.
  default pnSegundos := 5

  APPEND BLANK
  IF .NOT. NETERR()
    RETURN .T.
  ENDIF

  nSegundos := SECONDS()
  DO WHILE  ( SECONDS() - nSegundos ) < pnSegundos
    APPEND BLANK
    IF .NOT. NETERR()
      lExito := .T.
      RETURN(lExito)
    ENDIF
  ENDDO

  if ! lExito
    MsgStop( "No se pudo agregar el registro, vuelva a intentarlo...", oApp:cEmpresa )
  endif
RETURN( lExito)

// sirve para bloquear registros de una base de datos
// funcion publica pero con adecuaciones propias.
Function Rec_Lock( pnSegundos )
  local nSegundos := seconds()
  default pnSegundos := 5

  if rlock()
      return .t.                        // LOCKED
  endif

  DO WHILE ! rlock()

    IF rlock()
      RETURN( .T. )                    // LOCKED
    ENDIF

    If seconds() >= nSegundos + pnSegundos //nIntentos >= pnIntentos
      if MsgYesNo( "Ya se excedio el tiempo de espera del bloqueo, desea reintentar nuevamente ?", oApp:cEmpresa)
        nSegundos := seconds()
      else
        return(.f.)
      endif
    Endif

  enddo

RETURN( .F. )                          // NOT LOCKED

// sirve para validar que el numero que estamos tecleando este existente en el catalogo y si no es asi, nos muestra
// una ventana la cual nos permite seleccionar uno valido.
FUNCTION valcod( pcDato, pcBaseDatos, paNombres, bCampos, pcEncabezado)
  local lContinuar := .F.
  local cbuscar := space(100)
  local nTamano := 0, cEncontro := ""
  local oBrowse := nil, oDlg := nil, oGet := nil, oBtn := nil, oSay := nil
  local oFuente := nil
  local lNumeDesc := .F.

  default bCampos      := { || { id, nombre } },;
          paNombres    := { "id", "nombre" },;
          pcEncabezado := "Listado de: " + NomCatalogos(pcBaseDatos) + ": Ordenando por: Nombre"

  select (pcBaseDatos)

  if (pcBaseDatos)->(existeCampo("nume")) .and. (pcBaseDatos)->(existeCampo("desc"))
    bCampos      := { || { nume, desc } }
    cEncontro := space( len( (pcBaseDatos)->nume ) )
    lNumeDesc := .T.
  else
    if (pcBaseDatos)->(existeCampo("id")) .and. (pcBaseDatos)->(existeCampo("nombre"))
      cEncontro := space( len( (pcBaseDatos)->id ) )
    else
      cEncontro := space( len( (pcBaseDatos)->(fieldget(1)) ))
    endif
  endif

  (pcBaseDatos)->( OrdSetFocus( 1 ) )
  (pcBaseDatos)->(dbGoTop())

  If ! (pcBaseDatos)->(DbSeek(pcDato)) .and. ! (pcBaseDatos)->(DbSeek(cero1(pcDato)))

    DEFINE FONT oFuente  NAME "Arial" SIZE 0, 18 BOLD

    DEFINE DIALOG oDlg RESOURCE "DLG_MARIO" TITLE pcEncabezado FONT oApp:fNormal
      REDEFINE SAY oSay PROMPT upper(cBuscar) ID 101 OF oDlg COLOR CLR_RED UPDATE FONT oFuente

      REDEFINE LISTBOX oBrowse FIELDS ID 102 OF oDlg ;
                       ON DBLCLICK( lContinuar := .T., oDlg:End() ) UPDATE

        with object oBrowse
          :cAlias        := (pcBaseDatos)
          :cToolTip      := "Seleccione una opcion..."

          :bLine         := (bCampos)
          :bLogicLen     := {|| (pcBaseDatos)->(OrdKeyCount())}
          :bKeyChar      := { | nKey | lContinuar := f_bKeyDown( nKey, oDlg, oBrowse, pcBaseDatos, paNombres ) }
          :bSeek         := { | | oBrowse:DbfSeek( .T. ) }
          :bUpdateBuffer := { | | ( cBuscar := oBrowse:cBuffer, oDlg:Update() ) }
          :bFont         := { | nRow, nCol, nStyleLine | SeleccionaFuente( nRow, nCol, nStyleLine, oApp:fNormal, oApp:fBold, oApp:fBold, oApp:fBold ) }

          :aHeaders      := paNombres
          :aColSizes     := { 140, 140, 100 }
          :aJustify      := { 2, 0, 0, 0 } // 2 = centrado, 0 = Izquierda, 1 = Derecha
          :aHJustify     := { 2, 2, 2, 2 } // 2 = centrado, 0 = Izquierda, 1 = Derecha

          do case
            case len(paNombres) = 2
              :aActions      := { { || f_CambiarIndice( pcBaseDatos, paNombres[1], 1, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() },;
                                  { || f_CambiarIndice( pcBaseDatos, paNombres[2], 2, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() } }
            case len(paNombres) = 3
              :aActions      := { { || f_CambiarIndice( pcBaseDatos, paNombres[1], 1, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() },;
                                  { || f_CambiarIndice( pcBaseDatos, paNombres[2], 2, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() },;
                                  { || f_CambiarIndice( pcBaseDatos, paNombres[3], 3, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() } }
            case len(paNombres) = 4
              :aActions      := { { || f_CambiarIndice( pcBaseDatos, paNombres[1], 1, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() },;
                                  { || f_CambiarIndice( pcBaseDatos, paNombres[2], 2, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() },;
                                  { || f_CambiarIndice( pcBaseDatos, paNombres[3], 3, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() },;
                                  { || f_CambiarIndice( pcBaseDatos, paNombres[4], 4, oBrowse, oDlg ), cBuscar := space(100), oDlg:Update() } }
          end case

          :nHeaderStyle  := 3
          :nFooterStyle  := 3
          :nHeaderHeight := 25 // 20
          :nLineStyle    := 10 // 3
          :nLineHeight   := 22
          :nFreeze       := len(panombres)//1

          :nClrForeFocus := CLR_WHITE      // { || CLR_BLACK }
          :nClrBackFocus := nRGB(0,78,152) // { || nRGB( 255, 255, 128 ) }
          :nClrBackHead  := nRGB(105,132,192)
          :nClrForeHead  := CLR_WHITE      //CLR_BLUE
          :nClrPane      := { || IIF( (pcBaseDatos)->( OrdKeyNo() ) % 2 == 0, nRGB( 193, 221, 255 ), nRGB( 221, 245, 255 ) ) }

          :lCellStyle     := .F.
          :lAdjLastCol    := .T.
          :lDrawFocusRect := .F.

          // Footer's
          /*
          :lDrawFooters  :=.T.
          :nFooterStyle  := 6
          :nFooterHeight := 25
          :aFJustify     := { 2,2 }
          :aFooters      := {|| { Alltrim(Transform((pcBaseDatos)->(OrdKeyCount()),'9,999,999'))+" Reg(s)", "" } }
          */

        end with

      REDEFINE BUTTONBMP oBtn ID 103 OF oDlg PROMPT "A&ceptar " BITMAP "BTN_OK" TEXTRIGHT ;
              ACTION ( lContinuar := .T., oDlg:End() ) ;
              MESSAGE "Aceptar" UPDATE
              oBtn:cToolTip := "Presione para Continuar"


      ACTIVATE DIALOG oDlg ;
              ON INIT ( f_CambiarIndice( pcBaseDatos, paNombres[ 1 ], 1 , oBrowse, oDlg ) , cBuscar := space(100), oDlg:Update() ) CENTERED

  else
    lContinuar := .T.
    cEncontro := (pcBaseDatos)->(fieldget(1))
  Endif

  if lContinuar
    cEncontro := (pcBaseDatos)->(fieldget(1))
  endif

  // Seleccionamos como abrir los indices, si es por cdx por el nombre y si es ntx por el numero de indice
  // y como pudimos haber seleccionado por otro medio, le dejo el indice primario como default de nuevo...
  // LFRR 02/03/2006 11:39a.
      (pcBaseDatos)->(OrdSetFocus( 1 /*"ID"*/))

RETURN (cEncontro)

function cero1(pcCantidad)
  cFinal := ""
  cFinal = replicate('0',(len(pcCantidad) - len(alltrim(pcCantidad)))) + alltrim(pcCantidad)
return( cFinal )

function f_bKeyDown( pnKey, poDlg, poBrowse, pcBaseDatos, paNombres )
  local lContinuar := .F.

  do case
    case pnKey == 13
      lContinuar := .T.
      poDlg:End()
    case pnKey == 27
      poDlg:End()
  end case
return( lContinuar )

// Funcion que regresa una fecha valida en el formato DD/MESENLETRA/AAAA 01 DE ENERO DE 2001
// Luis Fernando Rubio Rubio
// Forma de Uso:
//              donde pdFecha es una variable de tipo fecha en donde esta almacenada una fecha cualesquiera
function FechaCompleta(pdFecha)
  LOCAL aMeses  := {'Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre'}
  LOCAL cCadena := ''
  default pdFecha := date()

  IF EMPTY(pdFecha)
    cCadena := 'Todas las fechas'
  ELSE
    cCadena := ALLTRIM(STR(DAY(pdFecha)))+' de '+aMeses[MONTH(pdFecha)]+' del '+ALLTRIM(STR(YEAR(pdFecha)))
  ENDIF
RETURN(cCadena)

/*function de calendario*/
//********************************************************************************************************************//
// Calendarios
// funcion que muestra un calendario para seleccionar fechas...
Function Calendario(pdDate,pcTitulo)
  LOCAL oDialogo, oBrowse, aSemanas, nSemana  := 1, cMes, oMes, nMes, nAno, oAno, lSelect  := .f.,;
        aMes     := { "Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre" },;
        dSelect := DATE()

  DEFAULT pdDate := DATE(), pcTitulo := "Seleccione la Fecha"

    *IF EMPTY(pdDate) // Agregado el 11/05/2001 LFRR, tronaba cuando el rango estaba vacio
    *  pdDate := DATE()
    *ENDIF

    dSelect := pdDate
    cMes  = aMes[ nMes := MONTH(pdDate) ]
    nAno  = YEAR(pdDate)
    aSemanas = aSemanas(nMes,nAno)

    DEFINE DIALOG oDialogo RESOURCE "DLG_CALENDARIO" TITLE pcTitulo FONT oApp:fNormal
      REDEFINE COMBOBOX oMes VAR cMes ID 101 OF oDialogo ITEMS aMes ;
               ON CHANGE ( aSemanas := aSemanas(oMes:nAt,nAno) ,;
                           dSelect  := RowColDate( DAY(dSelect), oMes:nAt, nAno, oBrowse, @nSemana ) )

      REDEFINE GET oAno VAR nAno ID 102 OF oDialogo ;
               SPINNER ON UP ( ++nAno,;
                               oAno:Refresh(),;
                               EVAL(oAno:bValid)) ;
                       ON DOWN ( --nAno,;
                                 oAno:Refresh(),;
                                 EVAL(oAno:bValid)) ;
                       MIN 0 MAX 9999 ;
               VALID ( aSemanas := aSemanas(oMes:nAt,nAno) ,;
                       dSelect  := RowColDate( DAY(dSelect), oMes:nAt, nAno, oBrowse, @nSemana), .T. )
       REDEFINE LISTBOX oBrowse ;
               FIELDS aSemanas[nSemana][1], aSemanas[nSemana][2], aSemanas[nSemana][3],  aSemanas[nSemana][4], ;
                      aSemanas[nSemana][5], aSemanas[nSemana][6], aSemanas[nSemana][7] ;
               HEADERS "Lun", "Mar", "Mie", "Jue",;
                       "Vie", "Sab", "Dom" ;
               OF oDialogo ;
               ON CLICK dSelect := GetDate(VAL(aSemanas[nSemana][oBrowse:nColact]),oMes:nAt,nAno) ;
               ON DBLCLICK IIF( EMPTY(aSemanas[nSemana][oBrowse:nColAct]) ,;
                              ( nMes := oMes:nAt ,;
                                IIF( nSemana = 1 , ( --nMes , IIF(nMes<1,(nMes:=12,--nAno),) ) ,;
                                                   ( ++nMes , IIF(nMes>12,(nMes:=1,++nAno),) ) ) ,;
                                                   oMes:Set(aMes[nMes]), oAno:Refresh(),;
                                                   aSemanas := aSemanas(nMes,nAno) , dSelect := RowColDate(DAY(dSelect),oMes:nAt,nAno,oBrowse,@nSemana) ) ,;
                              ( lSelect := .t. , oDialogo:End() ) ) ID 100
              oBrowse:bGotop     := { || nSemana := MIN(EVAL(oBrowse:bLogicLen ),1) }
              oBrowse:bGoBottom  := { || nSemana := EVAL( oBrowse:bLogicLen) }
              oBrowse:bSkip      := { | nWant, nOld | nold := nSemana , nSemana += nWant,;
                                                      nSemana := MAX( 1, MIN( nSemana, EVAL( oBrowse:bLogicLen ) ) ), nSemana - nOld }
              oBrowse:bLogicLen  := { || LEN(aSemanas) }
              oBrowse:cAlias     := "Array"
              oBrowse:bKeydown   := { | nKey | IF ( nKey == VK_RETURN , EVAL(oBrowse:bLDblClick), EVAL(oBrowse:bLClicked) ) }
              oBrowse:aColSizes  := {25,25,25,25,25,25,25}
              oBrowse:lCellStyle := .T.

    ACTIVATE DIALOG oDialogo CENTERED ON INIT RowColDate( DAY(pdDate), nMes, nAno, oBrowse, @nSemana )
RETURN IIF(lSelect,GetDate(VAL(aSemanas[nSemana][oBrowse:nColact]),oMes:nAt,nAno),pdDate)

// Esta funcion cuelga de GET BITMAP
FUNCTION aSemanas(pnMes,pnAno)
  LOCAL aSemana := {{"","","","","","",""}}
  LOCAL dFecha  := CTOD("01/"+STRZERO(pnMes,2)+"/"+STRZERO(pnAno,4))
  LOCAL nDia    := IF( DOW(dFecha) = 1 , 7 , DOW(dFecha) - 1 )
  LOCAL nSemana := 1

  DO WHILE MONTH(dFecha) = pnMes
     IF nDia > 7
        nDia = 1
        ++nSemana
         AADD(aSemana,{"","","","","","",""})
     ENDIF
     aSemana[nSemana][nDia] = PADL( STR(DAY(dFecha)) , 4 )
     ++dFecha
     ++nDia
  ENDDO
RETURN(aSemana)

// Esta funcion cuelga de GET BITMAP
FUNCTION RowColDate(pnDia,pnMes,pnAno,poBrowse,pnSemana)
  LOCAL dFecha    := GetDate(pnDia,pnMes,pnAno)
  LOCAL dFirstDay := dFecha - DAY(dFecha)
  LOCAL nStep

  poBrowse:GoTop()
  poBrowse:nColPos  = 1
  poBrowse:nColAct  = IF( DOW(dFecha) = 1 , 7 , DOW(dFecha) - 1 )
  pnSemana = INT( ( DAY(dFecha) + DOW(dFirstDay) - 1 - poBrowse:nColAct + 7) / 7 )
  poBrowse:nRowPos = pnSemana
  poBrowse:Refresh()
RETURN(dFecha)

// Esta funcion cuelga de GET BITMAP
FUNCTION GetDate(pnDia,pnMes,pnAno)
  LOCAL dDate

  DO WHILE EMPTY( dDate := CTOD(STRZERO(pnDia,2)+"/"+STRZERO(pnMes,2)+"/"+STRZERO(pnAno,4)) )
        --pnDia
        pnDia = MAX(pnDia,1)
  ENDDO
RETURN(dDate)

/*termina funcion de calendario*/

function f_ValidaVacio( pVariable, cMensaje )
  local lResultado := .F.
  default cMensaje := "Campo Vacio, Introduzca valor..."

  if empty(pVariable); MsgStop( cMensaje, oApp:cEmpresa ); else; lResultado := .T.; endif
return( lResultado )

* En Donde :
* Mntol = Cantidad Nmerica a Transformar en Letra.
* moneda = Par metro Lgico para Tipo de Moneda, Puede Omitirse (Default .T.):
*          .T.= NUEVOS PESOS xx/100 MN.
*          .F.= DOLARES xx/100 USD.
* Retorna: Cadena que Contiene cantidad Transformada a Letra.
* Mario Fabian Morales Franco
******************************************************************************
FUNCTION NtoL( Mntol, moneda )
  Private Mtab_u,Mtab_d,Mtab_c,Mtab_x,pp,i,valor,value,n1,n2,n3,r,o,l, ley_m1,ley_m2
  default moneda := .t.

  ley_m1=" PESOS "                   && Default
  ley_m2="/100 M.N.)"

  IF .NOT. moneda              && Dolares xx/100 USD
    ley_m1=" DOLARES "
    ley_m2="/100 USD.)"
  ENDIF

  punto   = at(".",str(mntol))
  decimal = substr(str(mntol),punto+1,2)
  Mxtol   = left(str(mntol),punto-1) // Ltrim(Str(Mntol,12,0))
  Mntol   = Space(12-Len(Ltrim(Mxtol)))+Ltrim(Mxtol)

  Declare Mtab_u[9]
    Mtab_u[1]="UN"
    Mtab_u[2]="DOS"
    Mtab_u[3]="TRES"
    Mtab_u[4]="CUATRO"
    Mtab_u[5]="CINCO"
    Mtab_u[6]="SEIS"
    Mtab_u[7]="SIETE"
    Mtab_u[8]="OCHO"
    Mtab_u[9]="NUEVE"

  Declare Mtab_d[9]
    Mtab_d[1]="ONCE"
    Mtab_d[2]="DOCE"
    Mtab_d[3]="TRECE"
    Mtab_d[4]="CATORCE"
    Mtab_d[5]="QUINCE"
    Mtab_d[6]="DIECISEIS"
    Mtab_d[7]="DIECISIETE"
    Mtab_d[8]="DIECIOCHO"
    Mtab_d[9]="DIECINUEVE"

  Declare Mtab_c[9]
    Mtab_c[1]="CIENTO"
    Mtab_c[2]="DOSCIENTOS"
    Mtab_c[3]="TRESCIENTOS"
    Mtab_c[4]="CUATROCIENTOS"
    Mtab_c[5]="QUINIENTOS"
    Mtab_c[6]="SEISCIENTOS"
    Mtab_c[7]="SETECIENTOS"
    Mtab_c[8]="OCHOCIENTOS"
    Mtab_c[9]="NOVECIENTOS"

  Declare Mtab_x[9]
    Mtab_x[1]="DIEZ"
    Mtab_x[2]="VEINTE"
    Mtab_x[3]="TREINTA"
    Mtab_x[4]="CUARENTA"
    Mtab_x[5]="CINCUENTA"
    Mtab_x[6]="SESENTA"
    Mtab_x[7]="SETENTA"
    Mtab_x[8]="OCHENTA"
    Mtab_x[9]="NOVENTA"

  Declare Mtab_esp[3]
    Mtab_esp[1]=" MILLONES"
    Mtab_esp[2]=" MILLON"
    Mtab_esp[3]=" MIL"

  If VAL(Substr(Mntol,1,12))=0
    Mchar_res="(CERO"+ley_m1+decimal+ley_m2
    Return Mchar_res
  Endif

  If VAL(Substr(Mntol,1,12))=1
    Mchar_res="(UN"+ley_m1+decimal+ley_m2
    Return Mchar_res
  Endif

  Mchar_res = "("
  sw        = .f.
  mfirst    = .t.
  mlong     = Len(Mntol)-2
  For i=1 to mlong step 3
    valor=Substr(str(1000+val(Substr(Mntol,i,3)),4),2,3)
    value=val(valor)
    If value>0
      Do while .t.
        stor " " to r,o
        n1 = Substr(valor,1,1)
        n2 = Substr(valor,2,1)
        n3 = Substr(valor,3,1)
        If n1>"0"
          If n2="0" .and. n3="0"
            r=r-(" "+Mtab_c[&n1])
            If n1="1"
              r=" CIEN "
            EndIf
            Exit
          Else
            r=r-(" "+Mtab_c[&n1])  && novecientos
          EndIf
        EndIf

        If n3="0"
          r=r-(" "+Mtab_x[&n2])
          Exit
        EndIf

        If n2="2"
          r=r-(" "+"VEINTI")-Mtab_u[&n3]
          Exit
        EndIf

        If val(Substr(valor,2,2))>=20
          r=r-(" "+Mtab_x[&n2])-(" Y")
          r=r-(" "+Mtab_u[&n3])
          Exit
        EndIf

        If n2="0"
          r=r-(" "+Mtab_u[&n3])
          Exit
        EndIf

        If n3="0"
          r=r-(" "+Mtab_x[&n2])
          Exit
        EndIf

        r=r-(" "+Mtab_d[&n3])
        Exit
      EndDo

      Mchar_res=trim(Mchar_res)+r
      Do case
        case i>=1 .and. i<=3 .or. i>=7 .and. i<=9 .and. i<= 12
          Mchar_res = Mchar_res-' MIL'
          If i>=7 .and. i<=9
            sw=.t.
          Endif
        case i>=4 .and. i<=6
          If Value > 1
            Mchar_res=Mchar_res-Mtab_esp[1]
          Else
            Mchar_res=Mchar_res-Mtab_esp[2]
          Endif
      Endcase
    Endif
  Next

  If val(Substr(Mntol,1,3))>0 .and. val(Substr(Mntol,4,9))=0
    Mchar_res=Mchar_res-" MILLONES DE"
  Endif

  If val(Substr(Mntol,4,3))>0 .and. !sw .and. val(Substr(Mntol,10,3))=0
    Mchar_res=Mchar_res-" DE"
  EndIf

  Mchar_res = Mchar_res - ley_m1 + decimal + ley_m2
  If Substr(Mchar_res,2,1)=" "
    l=str(len(Mchar_res)-2,3)
    Mchar_res="("+Substr(Mchar_res,3,&l)
  EndIf
Return Mchar_res

// Sirve para checar que el area que queremos abrir no este en uso y si esta en uso nos regresa el numero de area y si no un cero.
function farea(pAlias) // Rafael Morfn Nieto  // Feb 1998
  local i := 0

  for i := 1 to 255
    if upper(alias(i)) == upper(pAlias)
      return(i)
    endif
  next
return(0)

function AcercaDe()
return( MsgInfo( oApp:cEmpresa +" - "+ oApp:cSistema + CRLF + CRLF +; // "GUI: "                   + FWVERSION + " " + FWCOPYRIGHT + CRLF +; "Compilador: "            + version()                     + CRLF +;
                 "Version: "               + oApp:xVersion                 + CRLF +;
                 "Programador: "           + oApp:cProgramador             + CRLF +;
                 "Sistema Operativo: "     + OS()                          + CRLF +;
                 "Soporte Tecnico email: " + oApp:cEmail                   + CRLF +;
                 "Soporte Tecnico Tel.: "  + oApp:cTelefono, "Informacion del Sistema" ) )












