// *********************************************************************************************
// Fecha de Inicio del Proyecto: 02/02/2004 01:28p.
// Programador: Luis Fernando Rubio Rubio
// Empresa: MPC Soft.
// Lenguaje de Desarrollo: Fivewin Harbour 2.4 November 2002, Harbour Alpha Build 43.0 Intl (Flex)
// Comentarios: Modulo de Catalogos del Sistema
// *********************************************************************************************

#INCLUDE "FiveWin.ch" // Libreria de Clipper para Windows
#INCLUDE "BtnGet.ch"  // Libreria BtnGet
#INCLUDE "Image.ch"   // Libreria Image para ver las fotos

#DEFINE CAPTURA  1
#DEFINE CONSULTA 2
#DEFINE BORRAR   3
#DEFINE CAMBIOS  4
#DEFINE INDICES  5

// Funcion que en base al nombre de la tabla, me regresa un nombre para el titulo de la ventana de captura
// 11/12/2003 11:28a. LFRR
function NomCatalogos( pcTabla )
  local cNombre := ""

  do case
    case Upper(pcTabla) == "USUARIOS"; cNombre := "Usuarios del Sistema" // Este va por default
    case Upper(pcTabla) == "LINEA"   ; cNombre := "Lineas"
    case Upper(pcTabla) == "PROVEEDO"; cNombre := "Proveedores"
    case Upper(pcTabla) == "ALMACEN" ; cNombre := "Almacenes"
    CASE Upper(pcTabla) == "CLIENTE";  cNombre := "Clientes"
    CASE Upper(pcTabla) == "CONCFAC";  cNombre := "Conc. Facturacion"

  endcase

return( iif( empty( cNombre ), StrCapFirst( pcTabla ), cNombre ) )

// Aqui hay que poner los catalogos que sea necesarios para trabajar
// 11/12/2003 11:28a. LFRR
function Catalogo(pcBaseDatos, plCatalogo, pcRuta )
  local abOpciones := {},;
        aOrdenes   := { { "id" }, { "nombre" } }
  default plCatalogo := .F.

  do case
    // la function f_usuarios() esta en comun/source/mios/seguro.prg   24/08/2006 01:49p. LFRR
    // la function f_Comunes()  esta en comun/source/mios/xcatalog.prg 19/09/2006 04:01p. LFRR
    case pcBaseDatos == "USUARIOS"; abOpciones := { "f_Usuarios( 1 )",     "f_Usuarios( 2 )",     "f_Usuarios( 4 )",     "f_Usuarios( 3 )",     "f_Usuarios( 5 )"     }
    case pcBaseDatos == "ARTICULO"; abOpciones := { "f_Articulo( 1 )",     "f_Articulo( 2 )",     "f_Articulo( 4 )",     "f_Articulo( 3 )",     "f_Articulo( 5 )"     }
    case pcBaseDatos == "ALMACEN";  abOpciones := { "f_Almacen( 1 )",      "f_Almacen( 2 )",      "f_Almacen( 4 )",      "f_Almacen( 3 )",      "f_Almacen( 5 )"      }
    case pcBaseDatos == "CLIENTE";  abOpciones := { "f_Clientes( 1 )",     "f_Clientes( 2 )",     "f_Clientes( 4 )",     "f_Clientes( 3 )",     "f_Clientes( 5 )"     }
    otherwise ;                     abOpciones := { "f_Comunes( 1 )",      "f_Comunes( 2 )",      "f_Comunes( 4 )",      "f_Comunes( 3 )",      "f_Comunes( 5 )"      }
  endcase

  xCatalogo(pcBaseDatos, abOpciones, aOrdenes, plCatalogo, pcRuta )
return(nil)

function f_Articulo( pnOperacion )
  local oDlg    := nil,;
        aoObjetos   := { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil },;
        aoSay   := { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil },;
        aoImage := { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil },;
        aoBtn   := { nil, nil }
  local cTitulo := ""
  local lContinuar := if( pnOperacion = 3, .T., .F. )
  local lEdita     := if( pnOperacion = 2, .F., .T. )

  local lLinea := .F., lProve := .F.

  local cId := "", cNombre := "", nPrecio := 0, nHospedaje := 0, nIva := 0, cIdConcFact := space(4)
  local nCosto := 0, nUltCosto := 0

  if ! net_use( "concfac",,,oApp:xDatos )
    dbCloseall(); return(nil)
  endif

  do case
    case pnOperacion = 1; cTitulo := "Detalle de: " +  NomCatalogos( "ARTICULO" ) + " - Alta de Registros"
    case pnOperacion = 2; cTitulo := "Detalle de: " +  NomCatalogos( "ARTICULO" ) + " - Consulta de Registros"
    case pnOperacion = 4; cTitulo := "Detalle de: " +  NomCatalogos( "ARTICULO" ) + " - Modificacin de Registros"
    case pnOperacion = 5;f_Indexar( "articulo", { { "id", "id" }, { "nombre", "nombre" } }, .t., ".\inventario\" ); return(nil)
  endcase


  if pnOperacion = 1
    cId         := IncDb("articulo")
    cNombre     := space(len(articulo->nombre))
    nPrecio     := 0
    nHospedaje  := 0
    nIva        := 0
    cIdConcFact := space(4)
    cConcepto   := ""

  Else
    cId         := articulo->id
    cNombre     := articulo->nombre
    nPrecio     := articulo->precio
    nHospedaje  := articulo->hospedaje
    nIva        := articulo->iva
    cIdConcFact := articulo->idconcfact

    cConcepto   := if( concfac->(dbseek( cIdConcFact  ) ), concfac->nombre, "NO ENCONTRADO" )
  endif

  DEFINE DIALOG oDlg RESOURCE "DLG_ARTICULOS" FONT oApp:fNormal TITLE cTitulo
    REDEFINE GET aoObjetos[1] VAR cId            ID 101 PICTURE "999999"      OF oDlg UPDATE ;
             MESSAGE "Codigo del Articulo" ;
             VALID ValIdDb("articulo", cId, pnOperacion) When lEdita .and. pnOperacion <> 4
             aoObjetos[1]:cToolTip  := "Introduzca el Numero de Identificacion"

    REDEFINE GET    aoObjetos[2] VAR cNombre     ID 102 PICTURE "@!"         OF oDlg UPDATE WHEN lEdita ;
             MESSAGE "Nombre del Articulo"
             aoObjetos[2]:cToolTip  := "Introduzca el Nombre"

    REDEFINE GET    aoObjetos[3] VAR nPrecio     ID 103 PICTURE "999,999.99" OF oDlg UPDATE WHEN lEdita ;
             MESSAGE "Costo promedio del Articulo"
             aoObjetos[3]:cToolTip  := "Introduzca el Costo promedio del Articulo"

    REDEFINE GET    aoObjetos[4] VAR nIVA        ID 104 PICTURE "99%"        OF oDlg UPDATE WHEN lEdita ;
             MESSAGE "IVA del Articulo o Servicio"
             aoObjetos[4]:cToolTip  := "Introduzca el IVA del Articulo o Servicio"

    REDEFINE GET    aoObjetos[5] VAR nHospedaje  ID 105 PICTURE "99%"        OF oDlg UPDATE WHEN lEdita ;
             MESSAGE "Impuestos sobre hospedaje del Articulo o Servicio"
             aoObjetos[5]:cToolTip  := "Introduzca el impuesto sobre hospedaje del Articulo o Servicio"

    REDEFINE GET    aoObjetos[6] VAR cIdConcFact ID 106 PICTURE "9999"       OF oDlg UPDATE WHEN lEdita ;
             MESSAGE "Concepto de Facturacion del Articulo" ;
             VALID EVAL( { || cIdConcFact   := ValCod(cIdConcFact, "concfac"),;
                              cConcepto     := concfac->nombre, oDlg:Update(), .T. } )
             aoObjetos[6]:cToolTip  := "Introduzca el Concepto de Facturacion del Articulo del Articulo"
    REDEFINE SAY    aoSay[1] PROMPT cConcepto   ID 206 OF oDlg COLOR if( lEdita, CLR_RED, CLR_GRAY ) FONT oApp:fBold UPDATE


      REDEFINE BUTTONBMP aoBtn[1] ID 400 OF oDlg PROMPT "A&ceptar " BITMAP "BTN_OK" TEXTRIGHT ;
              ACTION ( lContinuar := .T., oDlg:End() ) ;
              MESSAGE "Aceptar" UPDATE
              aoBtn[1]:cToolTip := "Presione para Continuar"

      REDEFINE BUTTONBMP aoBtn[2] ID 401 OF oDlg PROMPT "&Cancelar " BITMAP "BTN_CAN" TEXTRIGHT ;
              ACTION ( lContinuar := .F., oDlg:End() ) ;
              MESSAGE "Cancelar" UPDATE
              aoBtn[2]:cToolTip := "Presione para Cancelar"

  if pnOperacion <> 3
    ACTIVATE DIALOG oDlg CENTERED ON INIT OnInit( oDlg )
  endif

  // si presionastes aceptar
  if lContinuar
    do case
      case pnOperacion == 1 .or. pnOperacion == 4
        if if ( pnOperacion == 1, articulo->(add_rec(5)), articulo->(rec_lock(5)) )
            replace articulo->id         with cId,;
                    articulo->nombre     with cNombre,;
                    articulo->precio     with nPrecio,;
                    articulo->hospedaje  with nHospedaje,;
                    articulo->iva        with nIva,;
                    articulo->idconcfact with cIdConcFact
          articulo->(dbUnlock())
        endif

      case pnOperacion == 3 .and. msgyesno( "Esta seguro de Eliminar el Registro ?", oApp:cEmpresa )
        if articulo->(rec_lock())
          articulo->(dbDelete()); articulo->(dbUnlock())
        endif

    endcase
  endif

  concfac->(dbCloseArea())
return( nil )

function f_Clientes( pnOperacion )
  local oDlg  := nil,;
        aoObjetos := {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil},;
        aoSay := {nil, nil, nil, nil, nil, nil, nil, nil, nil},;
        aoBtn := {nil,nil},;
        aoImage := { nil, nil, nil, nil }
  local cTitulo := ""
  local cId := "", cNombre := "", cDomicilio := "", cCp := "", cCiudad_Edo := "", cPais := "", cTelefonos := "", cRFC := "", cObservacio := ""

  local lContinuar := if( pnOperacion = 3, .T., .F. )
  local lEdita     := if( pnOperacion = 2, .F., .T. )

  do case
    case pnOperacion = 1; cTitulo := "Detalle de: " +  NomCatalogos( "CLIENTE" ) + " - Alta de Registros"
    case pnOperacion = 2; cTitulo := "Detalle de: " +  NomCatalogos( "CLIENTE" ) + " - Consulta de Registros"
    case pnOperacion = 4; cTitulo := "Detalle de: " +  NomCatalogos( "CLIENTE" ) + " - Modificacin de Registros"
    case pnOperacion = 5; f_Indexar( "CLIENTE", { { "id", "id" }, { "nombre", "nombre" } }, .T. ); return(nil)
  endcase

  If pnOperacion = 1
    cId         := IncDb("CLIENTE")
    cNombre     := space(len(cliente->nombre))
    cDomicilio  := space(len(cliente->domicilio))
    cCp         := space(len(cliente->cp))
    cCiudad_Edo := space(len(cliente->ciudad_edo))
    cPais       := space(len(cliente->pais))
    cTelefonos  := space(len(cliente->telefonos))
    cRfc        := space(len(cliente->rfc))
    cObservacio := space(len(cliente->observacio))
  Else
    cId         := cliente->id
    cNombre     := cliente->nombre
    cDomicilio  := cliente->domicilio
    cCp         := cliente->cp
    cCiudad_Edo := cliente->ciudad_edo
    cPais       := cliente->pais
    cTelefonos  := cliente->telefonos
    cRfc        := cliente->rfc
    cObservacio := cliente->observacio
  EndIf

  DEFINE DIALOG oDlg RESOURCE "CAT_CLIENTES" FONT oApp:fNormal TITLE cTitulo
    REDEFINE GET aoObjetos[1] VAR cId PICTURE "999999" MESSAGE "Formato" ID 101 OF oDlg ;
      VALID ValIdDb("cliente", cId, pnOperacion) When lEdita .and. pnOperacion <> 4
    aoObjetos[1]:cToolTip := "Numero de Identificacion"

    REDEFINE GET aoObjetos[2] VAR cNombre   PICTURE "@!" MESSAGE "Nombre" ID 102 OF oDlg When lEdita
    aoObjetos[2]:cToolTip := "Nombre"

    REDEFINE GET aoObjetos[3] VAR cDomicilio PICTURE "@!" MESSAGE "Domicilio" ID 103 OF oDlg When lEdita
    aoObjetos[3]:cToolTip := "Domicilio"

    REDEFINE GET aoObjetos[5] VAR cCiudad_Edo PICTURE "@!" MESSAGE "Ciudad y Estado" ID 104 OF oDlg When lEdita
    aoObjetos[5]:cToolTip := "Ciudad y Estado"

    REDEFINE GET aoObjetos[4] VAR cCp PICTURE "99999" MESSAGE "Codigo Postal" ID 106 OF oDlg When lEdita
    aoObjetos[4]:cToolTip := "Codigo Postal"

    REDEFINE GET aoObjetos[7] VAR cPais PICTURE "@!" MESSAGE "Pais" ID 107 OF oDlg When lEdita
    aoObjetos[7]:cToolTip := "Pais"

    REDEFINE GET aoObjetos[8] VAR cTelefonos MESSAGE "Telefonos" ID 108 OF oDlg When lEdita
    aoObjetos[8]:cToolTip := "Telefonos"

    REDEFINE GET aoObjetos[9] VAR cRfc PICTURE "@!" MESSAGE "R.F.C." ID 110 OF oDlg When lEdita
    aoObjetos[9]:cToolTip := "Registro Federal de Contribuyentes"

    REDEFINE GET aoObjetos[11] VAR cObservacio PICTURE "@!" MESSAGE "Observaciones" ID 111 OF oDlg When lEdita
    aoObjetos[11]:cToolTip := "Observaciones"

    REDEFINE BUTTON aoBtn[1] ID 400 OF oDlg ACTION ( lContinuar := .T., oDlg:End() )
    aoBtn[1]:cToolTip := "Presione para Continuar"

    REDEFINE BUTTON aoBtn[2] ID 401 OF oDlg ACTION oDlg:End()
    aoBtn[1]:cToolTip := "Presione para Salir"

  IF pnOperacion <> 3
    ACTIVATE DIALOG oDlg CENTERED ON INIT OnInit( oDlg )
  ENDIF

  // si presionastes aceptar
  if ! lContinuar
    return(nil)
  endif

    Do Case
      Case pnOperacion == 1 // Altas
        if cliente->(add_rec())
          replace cliente->id         with cId
          replace cliente->nombre     with cNombre
          replace cliente->domicilio  with cDomicilio
          replace cliente->cp         with cCp
          replace cliente->ciudad_edo with cCiudad_Edo
          replace cliente->pais       with cPais
          replace cliente->telefonos  with cTelefonos
          replace cliente->rfc        with cRfc
          replace cliente->observacio with cObservacio
          cliente->(dbunlock())
        endif
      Case pnOperacion == 4 // Modificacion
        if cliente->(rec_lock())
          replace cliente->id         with cId
          replace cliente->nombre     with cNombre
          replace cliente->domicilio  with cDomicilio
          replace cliente->cp         with cCp
          replace cliente->ciudad_edo with cCiudad_Edo
          replace cliente->pais       with cPais
          replace cliente->telefonos  with cTelefonos
          replace cliente->rfc        with cRfc
          replace cliente->observacio with cObservacio
          cliente->(dbunlock())
        endif
    EndCase

  IF pnOperacion = 3 // Eliminacion
    IF msgyesno('Eliminar el Registro ?',oApp:cEmpresa)
      if cliente->(rec_lock())
        cliente->(dbDelete())
        cliente->(dbunlock())
      else
        MsgStop("no se pudo borrar",oApp:cEmpresa)
      Endif
    Endif
  ENDIF

return(nil)



