// *********************************************************************************************
// Fecha de Inicio del Proyecto: 19/05/2008 12:07p..
// Programador: L.I. Luis Fernando Rubio Rubio ( rubio.luisfernando@gmail.com )
// Empresa: Consultoria y Soluciones en Informatica.
// Lenguaje de Desarrollo: Fivewin for xHarbour, xHarbour
// Comentarios: Modulo de Impresion de Facturas
// *********************************************************************************************

#include "fivewin.ch"
#include "impresio.ch"
#include "tarray.ch"
#include "btnget.ch"

#DEFINE nClrBkHeader  nRGB( 255, 245, 238 )
#DEFINE nClrTxtHeader CLR_BLACK
#DEFINE CLR_NARANJA  RGB(255, 69, 0 )

function f_Cap_Fact( pnOperacion )
  local oDlg := nil,;
        aoObjetos := { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                       nil, nil, nil, nil, nil, nil, nil, nil, nil, nil },;
        aoBtn := { nil, nil, nil, nil, nil },;
        aoSay := { nil, nil, nil, nil },;
        oBrowse := nil,;
        lNuevo  := .F., cTitulo := "", cImagen := "", cAccion := ""

  local lOtro := .T., lContinuar := .F.,;
        lEdita := if( pnOperacion = 1, .T., .F.  ),;
        cHoraF := "", cLEtra := ""

  do case
    case pnOperacion = 1 // Captura
      cTitulo := "Nueva Factura"
      cImagen := "IMPRIMIR"
      cAccion := "&Imprimir"
    case pnOperacion = 2 // Consulta / Reimpresion
      cTitulo := "Consulta / Re-Impresion de Facturas"
      cImagen := "IMPRIMIR"
      cAccion := "&Re-Imprimir " + CRLF + "Factura "
    case pnOperacion = 3 // Eliminacion de Facturas
      cTitulo := "Eliminacion de Facturas"
      cImagen := "BASURA"
      cAccion := "&Eliminar " + CRLF + "Factura "
    case pnOperacion = 4 // Cancelacion de Facturas
      cTitulo := "Cancelacion de Facturas"
      cImagen := "BMP_BORRAR"
      cAccion := "&Cancelar " + CRLF + "Factura "
  end case

  if ! net_use( "cliente",,,  oApp:xDatos ) .or.; // Catalogo de Clientes
     ! Net_Use( "articulo",,, oApp:xDatos ) .or.; // Catalogo de Articulos
     ! net_use( "facturas",,, oApp:xDatos ) .or.; // Encabezados de las Facturas
     ! net_use( "det_fact",,, oApp:xDatos ) .or.; // Detalle de las Facturas
     ! net_use( "pos_fac",,,  oApp:xDatos )       // Posiciones de la Impresion de Facturas
    dbCloseAll(); return(nil)
  endif

  oFacturas := nil
  DEFINE STRUCT oFacturas
    STRUCT FIELD cIdArtic  INIT ""
    STRUCT FIELD cArticul  INIT ""
    STRUCT FIELD nCant     INIT 0
    STRUCT FIELD nPrecioU  INIT 0
    STRUCT FIELD nPorcIVA  INIT 0
    STRUCT FIELD nIVA      INIT 0
    STRUCT FIELD nPorcHos  INIT 0
    STRUCT FIELD nHospeda  INIT 0
    STRUCT FIELD nPorcDes  INIT 0
    STRUCT FIELD nDescto   INIT 0
    STRUCT FIELD nImporte  INIT 0
    STRUCT FIELD nRegistro INIT 0
  END STRUCT
  oFacturas:Zap()


  do while lOtro
    cLetra := ""
    oFacturas:Zap()

    cNumFact   := if( pnOperacion = 1, f_GetNewIdFactura(), space(10) )

    dFecha     := date()
    cIdCliente := space(4)

    cNombre    := space(100)
    cDomicilio := space(100)
    cTelefono  := space(50)
    cCP        := space(5)
    cRFC       := space(14)
    cCiudadEdo := space(50)
    cComenta1  := space(50)
    cComenta2  := space(50)
    cHabita    := space(4)
    nPersonas  := 0

    nSubTot    := 0
    nDescto    := 0
    nIVA       := 0
    nTotal     := 0
    nHospe     := 0


    mEdita     := .F.

    DEFINE DIALOG oDlg RESOURCE "DLG_CAP_FACT" FONT oApp:fNormal //OF oWnd
      if pnOperacion = 1
        REDEFINE GET    aoObjetos[1]  VAR cNumFact    PICTURE "!!!!!!!!!!"       ID 101 OF oDlg UPDATE ;
                VALID ! f_Existe_Factura( pnOperacion )
                aoObjetos[1]:cToolTip := "Introduzca el Numero de Factura"
      else
        REDEFINE GET    aoObjetos[1]  VAR cNumFact    PICTURE "!!!!!!!!!!"       ID 101 OF oDlg UPDATE ;
                 VALID Eval ( { || cFolio := ValCod( cNumFact, "facturas", { "Factura" }, { || { facturas->numero } } ),;
                                   f_CargaDatos( oBrowse ), oDlg:Update(), .T. } )
                aoObjetos[1]:cToolTip := "Seleccione o Introduzca el Numero de Factura"
      endif

      REDEFINE BTNGET aoObjetos[2]  VAR dFecha     PICTURE "@D"                ID 102 OF oDlg UPDATE WHEN lEdita ;
               RESOURCE "BMP_CALENDARIOPQ" ACTION ( dFecha := Calendario(), oDlg:Update() )
               aoObjetos[2]:cToolTip := "Introduzca o Seleccione la Fecha de la Factura"

      REDEFINE GET    aoObjetos[16] VAR cHabita    PICTURE "9999"              ID 116 OF oDlg UPDATE WHEN lEdita
               aoObjetos[16]:cToolTip := "Introduzca el Numero de Habitacion"

      REDEFINE GET    aoObjetos[17] VAR nPersonas  PICTURE "999"               ID 117 OF oDlg UPDATE WHEN lEdita
               aoObjetos[17]:cToolTip := "Introduzca el Numero de Personas en la Habitacion"

      REDEFINE BTNGET aoObjetos[4]  VAR cIdCliente PICTURE "@!"                ID 104 OF oDlg UPDATE WHEN lEdita ;
              RESOURCE "BMP_CATALOGO" ACTION ( Catalogo( "CLIENTE", .T.), aoObjetos[4]:SetFocus(), oDlg:Update() ) ;
               VALID If( cIdCliente = "9999", ( mEdita := .t., .T. ), .F. ) .or. ;
                     Eval ( { || cIdCliente := valcod( cIdCliente, "cliente"),;
                                 cNombre := cliente->nombre, cDomicilio := cliente->domicilio, cCP := cliente->cp, cRFC := cliente->rfc,;
                                 cCiudadEdo := cliente->ciudad_edo, cTelefono := cliente->telefonos, oDlg:Update(), .T. } )
                aoObjetos[4]:cToolTip := "Introduzca o Seleccione el Cliente a facturar"

      REDEFINE GET    aoObjetos[13] VAR cNombre    PICTURE "@!"           ID 113 OF oDlg UPDATE WHEN mEdita
               aoObjetos[13]:cToolTip := "Introduzca el Nombre o Razon Social de Facturacion"

      REDEFINE GET    aoObjetos[5]  VAR cRFC       PICTURE "@!"           ID 105 OF oDlg UPDATE WHEN mEdita
               aoObjetos[5]:cToolTip := "Introduzca el Registro Federal de Causantes"

      REDEFINE GET    aoObjetos[6]  VAR cDomicilio PICTURE "@!"           ID 106 OF oDlg UPDATE WHEN mEdita
               aoObjetos[6]:cToolTip := "Introduzca la Direccion"

      REDEFINE GET    aoObjetos[7]  VAR cTelefono  PICTURE "@!"           ID 107 OF oDlg UPDATE WHEN mEdita
               aoObjetos[7]:cToolTip := "Introduzca el Telefono"

      REDEFINE GET    aoObjetos[8]  VAR cCP        PICTURE "99999"        ID 108 OF oDlg UPDATE WHEN mEdita
               aoObjetos[8]:cToolTip := "Introduzca el Codigo Postal"

      REDEFINE GET    aoObjetos[10] VAR cCiudadEdo PICTURE "@!"           ID 110 OF oDlg UPDATE WHEN mEdita
               aoObjetos[10]:cToolTip := "Introduzca la Ciudad"

      REDEFINE GET    aoObjetos[14]  VAR cComenta1 PICTURE "@!"           ID 114 OF oDlg UPDATE WHEN lEdita
               aoObjetos[14]:cToolTip := "Introduzca algun comentario acerca de la factura"

      REDEFINE GET    aoObjetos[15]  VAR cComenta2 PICTURE "@!"           ID 115 OF oDlg UPDATE WHEN lEdita
               aoObjetos[15]:cToolTip := "Introduzca algun comentario acerca de la factura"

      REDEFINE BUTTONBMP aoBtn[1] ID 400 OF oDlg PROMPT cAccion BITMAP cImagen TEXTRIGHT ;
              ACTION ( lContinuar := .T., oDlg:End() ) ;
              WHEN ! Empty(cIdCliente) .and. len(oFacturas:aDatos) > 0 ;
              MESSAGE cAccion UPDATE
              aoBtn[1]:cToolTip := "Presione para Continuar"


      REDEFINE BUTTONBMP aoBtn[2] ID 401 OF oDlg PROMPT "&Cancelar " BITMAP "BOTON_CANCELAR" TEXTRIGHT ;
              ACTION ( lContinuar := .F., oDlg:End() ) ;
              MESSAGE "Cancelar" UPDATE
              aoBtn[2]:cToolTip := "Presione para Cancelar"

      REDEFINE BUTTONBMP aoBtn[3] ID 402 OF oDlg PROMPT "&Salir " BITMAP "SALIR" TEXTRIGHT ;
              ACTION ( lContinuar := .F., oDlg:End(), lOtro := .F. ) CANCEL ;
              MESSAGE "Salir" UPDATE
              aoBtn[3]:cToolTip := "Presione para Salir"

      REDEFINE BUTTONBMP aoBtn[4] ID 403 OF oDlg PROMPT "&Ins " BITMAP "NEW" TEXTRIGHT ;
              ACTION ( f_Detalle_Registro( oBrowse, 1 ), oDlg:Update() ) ;
              MESSAGE "Insertar un nuevo concepto a la factura" UPDATE ;
              WHEN lEdita
              aoBtn[4]:cToolTip := "Presione para Insertar un nuevo concepto a la factura"

      REDEFINE BUTTONBMP aoBtn[5] ID 404 OF oDlg PROMPT "&Del " BITMAP "ERASE" TEXTRIGHT ;
              ACTION ( f_Detalle_Registro( oBrowse, 3 ), oDlg:Update() ) ;
              MESSAGE "Eliminar un concepto de la factura" UPDATE;
              WHEN lEdita
              aoBtn[5]:cToolTip := "Presione para Eliminar un concepto de la factura"

      REDEFINE LISTBOX oBrowse FIELDS ID 500 OF oDlg UPDATE

        WITH OBJECT oBrowse
          :SetArray( oFacturas:aDatos )

          :cAlias       := "ARRAY"
          :cTooltip     := "Detalle de Conceptos de Facturacion"
          :aHeaders     := { "cantidad", "descripcion", "% descto.", "p. unitario", "importe" }
          :aJustify     := { 1, 0, 1, 1, 1 } // 2 = centrado, 0 = Izquierda, 1 = Derecha

          :aHJustify    := { 2, 2, 2, 2, 2 } // 2 = centrado, 0 = Izquierda, 1 = Derecha
          :aFJustify    := { 1, 0, 1, 1, 1 } // 2 = centrado, 0 = Izquierda, 1 = Derecha

          :aColSizes    := { 80, 270, 80, 80, 100 }

          :aFooters     := { "", "", "", "SubTotal:"  + CRLF +;
                                         "Descuento:" + CRLF +;
                                         "I.V.A.:"    + CRLF +;
                                         "Hospedaje:" + CRLF +;
                                         "Total:",;
                                         transform( nSubTot, "999,999,999.99" ) + CRLF +;
                                         transform( nDescto, "999,999,999.99" ) + CRLF +;
                                         transform( nIVA,    "999,999,999.99" ) + CRLF +;
                                         transform( nHospe,  "999,999,999.99" ) + CRLF +;
                                         transform( nTotal,  "999,999,999.99" ) }

          :bLine        := { || { transform( oFacturas:nCant,    "99,999,999.99" ),;
                                  oFacturas:cIdArtic + CRLF + oFacturas:cArticul ,;
                                  transform( oFacturas:nDescto,  "999%" ),;
                                  transform( oFacturas:nPrecioU, "99,999,999.99" ),;
                                  transform( oFacturas:nImporte, "99,999,999.99" ) } }

          :bLogicLen    := { || Len( oFacturas:aDatos ) }
          :bTextColor   := { | nRow,nCol,nStyleLine | iif( ( (nStyleLine=1 .or. nStyleLine = 2) ), nClrTxtHeader, ) }
          :bBkColor     := { | nRow,nCol,nStyleLine | iif( ( (nStyleLine=1 .or. nStyleLine = 2) ), nClrBkHeader, ) }
          :bSkip        := { | nSkip | oFacturas:skip(nSkip)}

          // Datas que son estandares en los modulos
          :bFont         := { | nRow, nCol, nStyleLine | SeleccionaFuente( nRow, nCol, nStyleLine, oApp:fNormal, oApp:fBold, oApp:fBold, oApp:fBold ) }
          :nHeaderHeight := 30
          :nFooterHeight := 70
          :nHeaderStyle  := 3
          :nFooterStyle  := 3
          :nLineHeight   := 30
          :nClrPane      := { || iif( oFacturas:Recno() % 2 == 0, nRGB( 193, 221, 255 ), nRGB( 221, 245, 255 ) ) }
          :nClrForeFocus := { || CLR_WHITE }
          *:nFreeze       := 5

          :lCellStyle    := .F.
          :lAdjLastCol   := .T.
          :lOnlyBorder   := .T.
          :lAdjBrowse    := .T.
          :lDrawFooters  := .T.
        END WITH

    ACTIVATE DIALOG oDlg CENTERED

    if lContinuar
      do case
        case pnOperacion = 1 .and. lContinuar
          // lo almaceno desde aqui porque quiero guardar la misma hora en todos los registros que lo necesiten
          cHoraF := time()

          // guardamos el encabezado de las facturas
          select facturas
          if facturas->(add_rec())
            replace facturas->numero     with cNumFact,;
                    facturas->fecha      with dFecha,;
                    facturas->idcliente  with cIdCliente,;
                    facturas->descto     with nDescto,; // de las variables privadas de los totales
                    facturas->subtotal   with nSubTot,; // de las variables privadas de los totales
                    facturas->total      with nTotal,;  // de las variables privadas de los totales
                    facturas->iva        with nIva,;    // de las variables privadas de los totales
                    facturas->hospedaje  with nHospe,;  // de las variables privadas de los totales
                    facturas->come1      with cComenta1,;
                    facturas->come2      with cComenta2,;
                    facturas->usuario    with oApp:cIniciales,;
                    facturas->hora       with cHoraF,;
                    facturas->habitacion with cHabita,;
                    facturas->personas   with nPersonas
            facturas->(dbUnlock())
          endif

          // Luego almacenamos el detalle de las facturas
          oFacturas:GoTop()
          select det_fact
          do while ! oFacturas:Eof()
            if det_fact->(add_rec(5))
              replace det_fact->numero     with cNumFact,;
                      det_fact->idarticulo with oFacturas:cIdArtic,;
                      det_fact->cantidad   with oFacturas:nCant,;
                      det_fact->precio     with oFacturas:nPrecioU,;
                      det_fact->porciva    with oFacturas:nPorcIVA,;
                      det_fact->iva        with oFacturas:nIVA,;
                      det_fact->porchospe  with oFacturas:nPorcHos,;
                      det_fact->hospedaje  with oFacturas:nHospeda,;
                      det_fact->porcdesc   with oFacturas:nPorcDes,;
                      det_fact->descto     with oFacturas:nDescto,;
                      det_fact->importe    with oFacturas:nImporte,;
                      det_fact->concepto1  with oFacturas:cArticul
              det_fact->(dbUnlock())
            endif

            oFacturas:Skip(1)
          enddo

          lSaveCfg( "CFACTURA", cNumFact, "C" )

          f_ImprimeFactura()

        case pnOperacion = 2 .and. MsgYesno("Desea re-imprimir la Factura ?", oApp:cEmpresa)
          f_ImprimeFactura()

        case pnOperacion = 3
          if Alert("Seleccione la accion a aplicar a esta factura", {"Eliminar", "Cancelar"}, oApp:cEmpresa) = 1
            if MsgNoYes("Esta seguro de eliminar la factura:" + cNumFact, oApp:cEmpresa)
              if facturas->(rec_lock())
                facturas->(dbDelete()); facturas->(dbUnlock())
              endif

              oFacturas:GoTop()
              do while ! oFacturas:eof()
                det_fact->(dbGoto(oFacturas:nRegistro))
                if det_fact->(rec_lock())
                  det_fact->(dbDelete()); det_fact->(dbUnlock())
                endif
                oFacturas:skip(1)
              enddo
            endif
          else
            if facturas->(rec_lock())
              if facturas->cance
                if MsgYesNo("Esta factura ya estaba cancelada, desea quitarle el estatus de cancelada?", oApp:cEmpresa)
                  replace facturas->cance with .F.
                endif
              else
                replace facturas->cance with .T.
              endif
              facturas->(dbUnlock())
            endif
          endif

      endcase

    endif
  enddo

  dbCloseAll()
return(nil)

Function f_Detalle_Registro( poBrowse, pnOperacion )
  local oDlg := nil,;
        aoObjetos := { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                       nil, nil, nil, nil, nil, nil, nil, nil, nil, nil },;
        aoBtn := { nil, nil, nil, nil },;
        aoSay := { nil, nil, nil, nil }
  local mPaso := 0, mpDescto := 0, mpIva := 0, nTotal1 := 0
  local lEdita := if(pnOperacion = 3, .F., .T. ), lContinuar := .F.
  local cIdArtic := space(6), cArticul := "", nCant := 1, nPrecioU := 0, nPorcIVA := 0, nImpu := 0, nPorcHos := 0, nHospeda := 0, nPorcDes := 0, nDescu := 0, nImporte := 0
  local nPor := 0, nInte := 0

  if pnOperacion = 1
    cIdArtic := space(6)
    cArticul := space(70)
    nCant    := 1
    nPrecioU := 0
    nPorcIVA := 0
    nImpu     := 0
    nPorcHos := 0
    nHospeda := 0
    nPorcDes := 0
    nDescu  := 0
    nImporte := 0
  else
    cIdArtic := oFacturas:cIdArtic
    cArticul := oFacturas:cArticul
    nCant    := oFacturas:nCant
    nPrecioU := oFacturas:nPrecioU
    nPorcIVA := oFacturas:nPorcIVA
    nImpu     := oFacturas:nIVA
    nPorcHos := oFacturas:nPorcHos
    nHospeda := oFacturas:nHospeda
    nPorcDes := oFacturas:nPorcDes
    nDescu  := oFacturas:nDescto
    nImporte := oFacturas:nImporte
  endif

  DEFINE DIALOG oDlg RESOURCE "DLG_CAP_FACT_1" FONT oApp:fNormal //OF oWnd

    // Generales
    REDEFINE GET    aoObjetos[1]  VAR cIdArtic PICTURE "@!"             ID 101 OF oDlg UPDATE WHEN lEdita ;
            VALID EVAL( { || cIdartic := ValCod( cIdartic, "articulo" ),;
                             cArticul := if(empty(cIdartic),"",articulo->nombre),; // Almaceno en una variable el nombre del articulo
                             nPrecioU := articulo->precio, nPorcIVA := articulo->iva, nPorcHos := articulo->hospedaje,;
                             nImporte := nCant * nPrecioU,;
                             nPor     := 1 + ( ( nPorcIva + nPorcHos ) / 100 ),;
                             nInte    := nImporte / nPor,;
                             nImpu    := nImpuestosValor( nInte, nPorcIVA ),; // nImpu    := nImpuestosValor( /*if(empty(nPorcHos), nImporte, */nInte/* )*/, nPorcIVA ),;
                             nHospeda := nImpuestosValor( nInte, nPorcHos ),;
                             oDlg:Update(), .T. } )
              aoObjetos[1]:cToolTip := "Introduzca o Seleccione el concepto de facturacion"

    REDEFINE GET    aoObjetos[2]  VAR cArticul PICTURE "@!"             ID 102 OF oDlg UPDATE WHEN lEdita
             aoObjetos[2]:cToolTip := "Introduzca descripcion para la factura"

    REDEFINE GET    aoObjetos[3]  VAR nCant    PICTURE "999"            ID 103 OF oDlg UPDATE WHEN lEdita ;
             VALID EVAL( { || nImporte := nCant * nPrecioU,;
                              nPor     := 1 + ( ( nPorcIva + nPorcHos ) / 100 ),;
                              nInte    := nImporte / nPor,;
                              nImpu    := nImpuestosValor( nInte, nPorcIVA ),; // nImpu    := nImpuestosValor( /*if(empty(nPorcHos), nImporte, */nInte/* )*/, nPorcIVA ),;
                              nHospeda := nImpuestosValor( nInte, nPorcHos ),;
                              oDlg:Update(), .T. })
             aoObjetos[3]:cToolTip := "Introduzca la cantidad"

    REDEFINE GET    aoObjetos[4]  VAR nPrecioU PICTURE "999,999,999.99" ID 104 OF oDlg UPDATE  WHEN lEdita ;
             VALID f_ValidaVacio(nPrecioU, "Es necesario un valor mayor a 0, verifique...") .and.;
                   EVAL( { || nImporte := nCant * nPrecioU,;
                              nPor     := 1 + ( ( nPorcIva + nPorcHos ) / 100 ),;
                              nInte    := nImporte / nPor,;
                              nImpu    := nImpuestosValor( nInte, nPorcIVA ),; // nImpu    := nImpuestosValor( /*if(empty(nPorcHos), nImporte, */nInte/* )*/, nPorcIVA ),;
                              nHospeda := nImpuestosValor( nInte, nPorcHos ),;
                              oDlg:Update(), .T. })
             aoObjetos[4]:cToolTip := "Introduzca el Costo unitario del articulo o servicio a facturar"

    // Impuestos
    REDEFINE GET    aoObjetos[5]  VAR nPorcIVA PICTURE "99%"           ID 105 OF oDlg UPDATE WHEN Empty(cIdArtic) .and. lEdita ;
             VALID EVAL( { || nImporte := nCant * nPrecioU,;
                              nPor  := 1 + ( ( nPorcIva + nPorcHos ) / 100 ),;
                              nInte := nImporte / nPor,;
                              nImpu := nImpuestosValor( nInte, nPorcIVA ), oDlg:Update(), .T. })
             aoObjetos[5]:cToolTip := "Introduzca el porcentaje de IVA"
    REDEFINE GET    aoObjetos[6]  VAR nImpu     PICTURE "999,999.99"    ID 205 OF oDlg UPDATE WHEN .F.

    REDEFINE GET    aoObjetos[7]  VAR nPorcHos PICTURE "99%"           ID 106 OF oDlg UPDATE WHEN Empty(cIdArtic) .and. lEdita ;
             VALID EVAL( { || nImporte := nCant * nPrecioU,;
                              nPor     := 1 + ( ( nPorcIva + nPorcHos ) / 100 ),;
                              nInte    := nImporte / nPor,;
                              nHospeda := nImpuestosValor( nInte, nPorcHos ), oDlg:Update(), .T. })
             aoObjetos[7]:cToolTip := "Introduzca el porcentaje de Impuestos Sobre Hospedaje"
    REDEFINE GET    aoObjetos[8]  VAR nHospeda PICTURE "999,999.99"    ID 206 OF oDlg UPDATE WHEN .F.

    // Descuentos
    REDEFINE GET    aoObjetos[9]  VAR nPorcDes PICTURE "999%"          ID 107 OF oDlg UPDATE WHEN Empty(cIdArtic) .and. lEdita
             aoObjetos[9]:cToolTip := "Introduzca el porcentaje de IVA"
    REDEFINE GET    aoObjetos[10] VAR nDescu PICTURE "999,999.99"      ID 207 OF oDlg UPDATE WHEN .F.

    // Total
    REDEFINE GET    aoObjetos[11] VAR nImporte PICTURE "999,999.99"    ID 108 OF oDlg UPDATE WHEN .F.
             aoObjetos[11]:cToolTip := "total calculado automaticamente"

    REDEFINE BUTTONBMP aoBtn[1] ID 400 OF oDlg PROMPT "A&ceptar " BITMAP "BTN_OK" TEXTRIGHT ;
            ACTION ( lContinuar := .T., oDlg:End() ) ;
            MESSAGE "Aceptar" UPDATE
            aoBtn[1]:cToolTip := "Presione para Continuar"

    REDEFINE BUTTONBMP aoBtn[2] ID 401 OF oDlg PROMPT "&Cancelar " BITMAP "BTN_CAN" TEXTRIGHT ;
            ACTION oDlg:End();
            MESSAGE "Cancelar" UPDATE
            aoBtn[2]:cToolTip := "Presione para Cancelar"

  ACTIVATE DIALOG oDlg CENTERED

  If ! lContinuar
    return(nil)
  endif

  do case
    case pnOperacion = 1

      with object oFacturas
        :cIdArtic := cIdArtic
        :cArticul := cArticul
        :nCant    := nCant
        :nPrecioU := nPrecioU
        :nPorcIVA := nPorcIVA
        :nIVA     := nImpu
        :nPorcHos := nPorcHos
        :nHospeda := nHospeda
        :nPorcDes := nPorcDes
        :nDescto  := nDescu
        :nImporte := nImporte - ( nHospeda + nImpu + nDescu )
        :Add()
      end with


      nDescto += nDescu
      nIVA    += nImpu
      nHospe  += nHospeda
      nTotal  += nImporte

      nSubTot := nTotal - ( nHospe + nIVA + nDescto)

      poBrowse:aFooters     := { "", "", "", "SubTotal:"  + CRLF +;
                                             "Descuento:" + CRLF +;
                                             "I.V.A.:"    + CRLF +;
                                             "Hospedaje:" + CRLF +;
                                             "Total:",;
                                             transform( nSubTot, "999,999,999.99" ) + CRLF +;
                                             transform( nDescto, "999,999,999.99" ) + CRLF +;
                                             transform( nIVA,    "999,999,999.99" ) + CRLF +;
                                             transform( nHospe,  "999,999,999.99" ) + CRLF +;
                                             transform( nTotal,  "999,999,999.99" ) }

    case pnOperacion = 3 .and. MsgYesNo( "Desea borrar este registro ?", oApp:cEmpresa )

      nDescto -= nDescu
      nIVA    -= nImpu
      nHospe  -= nHospeda
      nTotal  -= ( nImporte + nImpu + nHospeda )

//      nSubTot -= ( nImporte + nImpu + nHospeda )//nTotal - ( nHospeda + nImpu + nDescu )
      nSubTot -= nImporte// + nImpu + nHospeda )

      oFacturas:Delete()

      poBrowse:aFooters     := { "", "", "", "SubTotal:"  + CRLF +;
                                             "Descuento:" + CRLF +;
                                             "I.V.A.:"    + CRLF +;
                                             "Hospedaje:" + CRLF +;
                                             "Total:",;
                                             transform( nSubTot, "999,999,999.99" ) + CRLF +;
                                             transform( nDescto, "999,999,999.99" ) + CRLF +;
                                             transform( nIVA,    "999,999,999.99" ) + CRLF +;
                                             transform( nHospe,  "999,999,999.99" ) + CRLF +;
                                             transform( nTotal,  "999,999,999.99" ) }

  endcase

  oFacturas:GoTop()
return(nil)

static function f_CargaDatos( poBrowse )
  oFacturas:Zap()

  select facturas
  cNumFact   := facturas->numero
  dFecha     := facturas->fecha
  cIdCliente := facturas->idcliente
  cComenta1  := facturas->come1
  cComenta2  := facturas->come2
  cHabita    := facturas->habitacion
  nPersonas  := facturas->personas

  nSubTot    := facturas->subtotal
  nDescto    := facturas->descto
  nIVA       := facturas->iva
  nTotal     := facturas->total
  nHospe     := facturas->hospedaje

  if cliente->(dbseek(cIdCliente))
    cNombre    := cliente->nombre
    cDomicilio := cliente->domicilio
    cTelefono  := cliente->telefonos
    cCP        := cliente->cp
    cRFC       := cliente->rfc
    cCiudadEdo := cliente->ciudad_edo
  endif


  select det_fact
  if det_fact->(dbseek(cNumFact))
    do while det_fact->numero == cNumFact
      with object oFacturas
        :cIdArtic := det_fact->idarticulo
        :cArticul := det_fact->concepto1 // if( empty(det_fact->concepto1), if(articulo->(dbseek(det_fact->idarticulo)), articulo->nombre, "NO ENCONTRADO" ) )
        :nCant    := det_fact->cantidad
        :nPrecioU := det_fact->precio
        :nPorcIVA := det_fact->porciva
        :nIVA     := det_fact->iva
        :nPorcHos := det_fact->porchospe
        :nHospeda := det_fact->hospedaje
        :nPorcDes := det_fact->porcdesc
        :nDescto  := det_fact->descto
        :nImporte := det_fact->importe
        :nRegistro := det_fact->(recno())
        :Add()
      end with

      det_fact->(dbskip(1))
    enddo
  endif

  oFacturas:GoTop()
  poBrowse:aFooters     := { "", "", "", "SubTotal:"  + CRLF +;
                                          "Descuento:" + CRLF +;
                                          "I.V.A.:"    + CRLF +;
                                          "Hospedaje:" + CRLF +;
                                          "Total:",;
                                          transform( nSubTot, "999,999,999.99" ) + CRLF +;
                                          transform( nDescto, "999,999,999.99" ) + CRLF +;
                                          transform( nIVA,    "999,999,999.99" ) + CRLF +;
                                          transform( nHospe,  "999,999,999.99" ) + CRLF +;
                                          transform( nTotal,  "999,999,999.99" ) }
return(nil)


function f_ImprimeFactura()
  Local oPrn := nil
  local a := "0"

  a := "0"
  pos_fac->(dbgotop())
  do while ! pos_fac->(eof())

    // Asignacion de Posiciones a Variables
    a := str( val( a ) + 1, 2 )
    If substr( a, 1, 1 ) = " "
      a := substr( a, 2, 1 )
    Endif

    // y les asignamos los valores que les corresponde
    store pos_fac->renglon  to P1_&a
    store pos_fac->columna  to P2_&a
    store pos_fac->imprimir to P3_&a

    pos_fac->(dbskip())
  Enddo
  pos_fac->(dbgotop())

  MyPRINT oPrn FROM USER PREVIEW TITLE "Impresion de Facturas Cte.: " + alltrim(cliente->nombre)
    DEFINE FONT  oPrn:fNormal  NAME "Lucida Console" SIZE 0,-10      OF oPrn
    DEFINE FONT  oPrn:fBold    NAME "Lucida Console" SIZE 0,-10 BOLD OF oPrn
    DEFINE BRUSH oPrn:oBrush  COLOR CLR_GRAY
    DEFINE PEN   oPrn:oPen WIDTH 2

    oPrn:SetCopies( oApp:nCopias )
    oPrn:lPrvModal := .T.

    page
      oPrn:cmSay( P1_1,  P2_1,  if( P3_1,  cNumFact,     "" ), oPrn:fNormal ) // Numero de Factura
      oPrn:cmSay( P1_2,  P2_2,  if( P3_2,  dToc(dFecha), "" ), oPrn:fNormal ) // Fecha de Factura
      oPrn:cmSay( P1_3,  P2_3,  if( P3_3,  cNombre,      "" ), oPrn:fNormal ) // Nombre de Facturacion
      oPrn:cmSay( P1_4,  P2_4,  if( P3_4,  cDomicilio,   "" ), oPrn:fNormal ) // Domicilio de Facturacion
      oPrn:cmSay( P1_5,  P2_5,  if( P3_5,  cCiudadEdo,   "" ), oPrn:fNormal ) // Ciudad, Estado de Facturacion
      oPrn:cmSay( P1_6,  P2_6,  if( P3_6,  cCP,          "" ), oPrn:fNormal ) // Codigo Postal de Facturacion
      oPrn:cmSay( P1_7,  P2_7,  if( P3_7,  cTelefono,    "" ), oPrn:fNormal ) // Numero Telefonico
      oPrn:cmSay( P1_8,  P2_8,  if( P3_8,  cRFC,         "" ), oPrn:fNormal ) // RFC del cliente
      oPrn:cmSay( P1_9,  P2_9,  if( P3_9,  cHabita,      "" ), oPrn:fNormal ) // Numero de Habitacion
      oPrn:cmSay( P1_10, P2_10, if( P3_10, cComenta1,    "" ), oPrn:fNormal ) // Comentarios 1
      oPrn:cmSay( P1_11, P2_11, if( P3_11, cComenta2,    "" ), oPrn:fNormal ) // Comentarios 2
      oPrn:cmSay( P1_23, P2_23, if( P3_23, transform(nPersonas,"999"),    "" ), oPrn:fNormal ) // Numero de Personas en la habitacion

      oPrn:nLinea := P1_12  // Inicializamos nuestro contador de Renglones

      oFacturas:GoTop()
      do while ! oFacturas:eof()
        oPrn:nLinea += 00.30

        oPrn:cmSay( oPrn:nLinea, P2_13, if( P3_13, oFacturas:cArticul, "" ),                     oPrn:fNormal ) // Descripcion del Articulo
        oPrn:cmSay( oPrn:nLinea, P2_14, if( P3_14, transform( oFacturas:nCant,          "999" ), "" ), oPrn:fNormal ) // Cantidad
        oPrn:cmSay( oPrn:nLinea, P2_15, if( P3_15, transform( oFacturas:nPrecioU, "99,999.99" ), "" ), oPrn:fNormal ) // Precio Unitario
        oPrn:cmSay( oPrn:nLinea, P2_16, if( P3_16, transform( oFacturas:nDescto,  "99,999.99" ), "" ), oPrn:fNormal ) // Descuento
        oPrn:cmSay( oPrn:nLinea, P2_17, if( P3_17, transform( oFacturas:nImporte, "99,999.99" ), "" ), oPrn:fNormal ) // Importe
        oFacturas:Skip(1)
      enddo

      oPrn:cmSay( P1_18, P2_18, if( P3_18, nTol(nTotal), "" ),                        oPrn:fNormal ) // Cantidad con letra del total
      oPrn:cmSay( P1_19, P2_19, if( P3_19, transform( nSubTot,"9,999,999.99" ), "" ), oPrn:fNormal ) // SubTotal
      oPrn:cmSay( P1_20, P2_20, if( P3_20, transform( nIva,   "9,999,999.99" ), "" ), oPrn:fNormal ) // IVA
      oPrn:cmSay( P1_21, P2_21, if( P3_21, transform( nHospe, "9,999,999.99" ), "" ), oPrn:fNormal ) // Hospedaje
      oPrn:cmSay( P1_22, P2_22, if( P3_22, transform( nTotal, "9,999,999.99" ), "" ), oPrn:fNormal ) // Total de la Factura
    endpage
  endPrint
return(nil)

function f_GetNewIdFactura()
  local cNumFacT := ""
  local cLetra := ""

  cNumFact := getcfg("CFACTURA", "0000000000") //space(len((pcBdFact)->(pcCAmpo)))

  if IsAlpha( cNumFact )
    cLetra  := left( cNumFact, 1 )
    cNumFact := SubStr( cNumFact, 2, len( cNumFact ) )
  endif

  cNumFact   := cLetra + strzero( val( cNumFact ) + 1, if(empty( cLetra ),10 ,9) )
return( cNumFact )

static function f_Existe_Factura( pnOperacion )
  local lExiste := .F.

  do case
    case pnOperacion = 1
      if facturas->(dbseek(cNumFact))
        lExiste := .T.
        MsgStop( "El numero de Factura que Introdujo ya existe en el Sistema, Verifique...", oApp:cEmpresa )
      endif
  endcase
return(lExiste)

function f_Posiciones_Impresion()
  local oDlg := nil,;
        aoObjetos := { { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                         nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                         nil, nil, nil },;
                       { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                         nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                         nil, nil, nil },;
                       { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                         nil, nil, nil, nil, nil, nil, nil, nil, nil, nil,;
                         nil, nil, nil } },;
        aoBtn  := { nil, nil, nil, nil },;
        lEdita := .T.
  local lContinuar := .F., a := "0"
  local cTitulo := ""

  If ! net_use("pos_fac",,"posi",oApp:xDatos)
    dbcloseall(); return(nil)
  Endif

  if posi->(lastrec()) <> 23
    MsgStop("Faltan parametros necesarios para la impresion de: FACTURAS, consulte a su asesor...", oApp:cEmpresa)
    return(nil)
  endif

  // generamos dinamicamente las variables basados en los registros de la base de datos, tienen que ser 20
  a := "0"
  posi->(dbgotop())
  do while ! posi->(eof())

    // Asignacion de Posiciones a Variables
    a := str( val( a ) + 1, 2 )
    If substr( a, 1, 1 ) = " "
      a := substr( a, 2, 1 )
    Endif

    // y les asignamos los valores que les corresponde
    store posi->renglon  to P1_&a
    store posi->columna  to P2_&a
    store posi->imprimir to P3_&a

    posi->(dbskip())
  Enddo
  posi->(dbgotop())

  DEFINE DIALOG oDlg RESOURCE "DLG_POS_FACT" FONT oApp:fNormal TITLE cTitulo

    // Numero de Factura
    REDEFINE GET      aoObjetos[1,1]  VAR P1_1  PICTURE "99.99" ID 101 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,1]  VAR P2_1  PICTURE "99.99" ID 201 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,1]  VAR P3_1                  ID 301 OF oDlg UPDATE

    // Fecha de la Factura
    REDEFINE GET      aoObjetos[1,2]  VAR P1_2  PICTURE "99.99" ID 102 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,2]  VAR P2_2  PICTURE "99.99" ID 202 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,2]  VAR P3_2                  ID 302 OF oDlg UPDATE

    // Nombre a Facturar
    REDEFINE GET      aoObjetos[1,3]  VAR P1_3  PICTURE "99.99" ID 103 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,3]  VAR P2_3  PICTURE "99.99" ID 203 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,3]  VAR P3_3                  ID 303 OF oDlg UPDATE

    // Direccion
    REDEFINE GET      aoObjetos[1,4]  VAR P1_4  PICTURE "99.99" ID 104 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,4]  VAR P2_4  PICTURE "99.99" ID 204 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,4]  VAR P3_4                  ID 304 OF oDlg UPDATE

    // Poblacion, Estado
    REDEFINE GET      aoObjetos[1,5]  VAR P1_5  PICTURE "99.99" ID 105 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,5]  VAR P2_5  PICTURE "99.99" ID 205 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,5]  VAR P3_5                  ID 305 OF oDlg UPDATE

    // Codigo Postal
    REDEFINE GET      aoObjetos[1,6]  VAR P1_6  PICTURE "99.99" ID 106 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,6]  VAR P2_6  PICTURE "99.99" ID 206 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,6]  VAR P3_6                  ID 306 OF oDlg UPDATE WHEN lEdita

    // Numero Telefonico
    REDEFINE GET      aoObjetos[1,7]  VAR P1_7  PICTURE "99.99" ID 107 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,7]  VAR P2_7  PICTURE "99.99" ID 207 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,7]  VAR P3_7                  ID 307 OF oDlg UPDATE WHEN lEdita

    // R.F.C. del Cliente
    REDEFINE GET      aoObjetos[1,8]  VAR P1_8 PICTURE "99.99"  ID 108 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,8]  VAR P2_8 PICTURE "99.99"  ID 208 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,8]  VAR P3_8                  ID 308 OF oDlg UPDATE WHEN lEdita

    // Habitacion
    REDEFINE GET      aoObjetos[1,9]  VAR P1_9 PICTURE "99.99"  ID 109 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,9]  VAR P2_9 PICTURE "99.99"  ID 209 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,9]  VAR P3_9                  ID 309 OF oDlg UPDATE WHEN lEdita

    // Observaciones 1
    REDEFINE GET      aoObjetos[1,10] VAR P1_10 PICTURE "99.99"  ID 110 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,10] VAR P2_10 PICTURE "99.99"  ID 210 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,10] VAR P3_10                  ID 310 OF oDlg UPDATE WHEN lEdita

    // Observaciones 2
    REDEFINE GET      aoObjetos[1,11] VAR P1_11 PICTURE "99.99"  ID 111 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,11] VAR P2_11 PICTURE "99.99"  ID 211 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,11] VAR P3_11                  ID 311 OF oDlg UPDATE WHEN lEdita



    // Primer Detalle Factura
    REDEFINE GET      aoObjetos[1,12]  VAR P1_12 PICTURE "99.99"  ID 112 OF oDlg UPDATE

    // Descripcion
    REDEFINE GET      aoObjetos[2,13] VAR P2_13 PICTURE "99.99" ID 213 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,13] VAR P3_13                 ID 313 OF oDlg UPDATE

    // Cantidad
    REDEFINE GET      aoObjetos[2,14] VAR P2_14 PICTURE "99.99" ID 214 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,14] VAR P3_14                 ID 314 OF oDlg UPDATE

    // Precio Unitario
    REDEFINE GET      aoObjetos[2,15] VAR P2_15 PICTURE "99.99" ID 215 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,15] VAR P3_15                 ID 315 OF oDlg UPDATE

    // Descuento
    REDEFINE GET      aoObjetos[2,16] VAR P2_16 PICTURE "99.99" ID 216 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,16] VAR P3_16                 ID 316 OF oDlg UPDATE WHEN lEdita

    // Cantidad x Precio
    REDEFINE GET      aoObjetos[2,17] VAR P2_17 PICTURE "99.99" ID 217 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,17] VAR P3_17                 ID 317 OF oDlg UPDATE

    // Cantidad en Letra
    REDEFINE GET      aoObjetos[1,18] VAR P1_18 PICTURE "99.99" ID 118 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,18] VAR P2_18 PICTURE "99.99" ID 218 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,18] VAR P3_18                 ID 318 OF oDlg UPDATE

    // Sub-Total
    REDEFINE GET      aoObjetos[1,19] VAR P1_19 PICTURE "99.99" ID 119 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,19] VAR P2_19 PICTURE "99.99" ID 219 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,19] VAR P3_19                 ID 319 OF oDlg UPDATE WHEN lEdita

    // IVA
    REDEFINE GET      aoObjetos[1,20] VAR P1_20 PICTURE "99.99" ID 120 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,20] VAR P2_20 PICTURE "99.99" ID 220 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,20] VAR P3_20                 ID 320 OF oDlg UPDATE WHEN lEdita

    // Hospedaje
    REDEFINE GET      aoObjetos[1,21] VAR P1_21 PICTURE "99.99" ID 121 OF oDlg UPDATE WHEN lEdita
    REDEFINE GET      aoObjetos[2,21] VAR P2_21 PICTURE "99.99" ID 221 OF oDlg UPDATE WHEN lEdita
    REDEFINE CHECKBOX aoObjetos[3,21] VAR P3_21                 ID 321 OF oDlg UPDATE WHEN lEdita

    // Importe Total
    REDEFINE GET      aoObjetos[1,22] VAR P1_22 PICTURE "99.99" ID 122 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,22] VAR P2_22 PICTURE "99.99" ID 222 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,22] VAR P3_22                 ID 322 OF oDlg UPDATE

    // Numero de Personas
    REDEFINE GET      aoObjetos[1,23] VAR P1_23 PICTURE "99.99" ID 123 OF oDlg UPDATE
    REDEFINE GET      aoObjetos[2,23] VAR P2_23 PICTURE "99.99" ID 223 OF oDlg UPDATE
    REDEFINE CHECKBOX aoObjetos[3,23] VAR P3_23                 ID 323 OF oDlg UPDATE

    REDEFINE BUTTONBMP aoBtn[1] ID 400 OF oDlg PROMPT "A&ceptar " BITMAP "BTN_OK" TEXTRIGHT ;
             ACTION ( lContinuar := .T., oDlg:End() ) ;
             MESSAGE "Aceptar" UPDATE
             aoBtn[1]:cToolTip := "Presione para Continuar"

    REDEFINE BUTTONBMP aoBtn[2] ID 401 OF oDlg PROMPT "&Cancelar " BITMAP "BTN_CAN" TEXTRIGHT ;
             ACTION ( lContinuar := .F., oDlg:End() ) ;
             MESSAGE "Cancelar" UPDATE
             aoBtn[2]:cToolTip := "Presione para Cancelar"

  ACTIVATE DIALOG oDlg CENTERED

  if ! lContinuar
    dbCloseAll(); return(nil)
  endif

   If MsgYesNo( "Desea guardar sus cambios ?", oApp:cEmpresa )
      a := "0"
      posi->(dbgotop())
      do while ! posi->(eof())  // Grabado las Nuevas Posiciones

          a := str(val(a)+1,2)
          If substr(a,1,1)=" "
              a := substr(a,2,1)
          Endif

          if posi->(rec_lock())
            repla posi->renglon  with P1_&a,;
                  posi->columna  with P2_&a,;
                  posi->imprimir with p3_&a
            posi->(dbUnlock())
          endif
        posi->(dbskip())
      enddo

      dbcommit()
   Endif

  dbcloseall()
return( nil )




