// *********************************************************************************************
// Fecha de Inicio del Proyecto: 02/02/2004 01:28p.
// Programador: Luis Fernando Rubio Rubio
// Empresa: MPC Soft.
// Lenguaje de Desarrollo: Fivewin Harbour 2.4 November 2002, Harbour Alpha Build 43.0 Intl (Flex)
// Comentarios: Modulo de Funciones Comunes y Utiles dentro del sistema
// *********************************************************************************************

#include "fivewin.ch"
#include "btnget.ch"

Function f_IpLocal()
 local cIp := ""

 if WSaStartup() == 0
   cIp := ServerIp()
   WSaCleanUp()
 endif
Return(cIp)

function f_fechas()
  local aoGet := {nil,nil}, aoBtn := {nil,nil}, aoSay := {nil,nil}
  local adFechas := {date(), date()}
  local lContinuar := .F.

  DEFINE DIALOG oDlg RESOURCE "DLG_FECHAS" FONT oApp:fBold OF oApp:oWnd
    REDEFINE BTNGET aoGet[1]  VAR adFechas[1] PICTURE "@D" MESSAGE "Fecha Inicial" ID 101 OF oDlg  UPDATE;
      RESOURCE "BMP_CALENDARIOPQ" ACTION ( adFechas[1] := Calendario(), aoGet[1]:SetFocus(), oDlg:Update() );
      VALID ( oDlg:Update(), .T. )
    REDEFINE SAY aoSay[1] PROMPT fechaCompleta(adFechas[1]) ID 201 Of oDlg COLOR CLR_RED FONT oApp:fBold UPDATE

    REDEFINE BTNGET aoGet[2]  VAR adFechas[2] PICTURE "@D" MESSAGE "Fecha Inicial" ID 102 OF oDlg UPDATE;
      RESOURCE "BMP_CALENDARIOPQ" ACTION ( adFechas[2] := Calendario(), aoGet[2]:SetFocus(), oDlg:Update() ) ;
      VALID ( oDlg:Update(), .T. )
    REDEFINE SAY aoSay[2] PROMPT fechaCompleta(adFechas[2]) ID 202 Of oDlg COLOR CLR_RED FONT oApp:fBold UPDATE

    REDEFINE BUTTON aoBtn[1] ID 400 OF oDlg ACTION ( lContinuar := .T., oDlg:End() )
    REDEFINE BUTTON aoBtn[2] ID 401 OF oDlg ACTION oDlg:End()

    aoGet[1]:cTooltip := "Introduzca o seleccione la Fecha Inicial"
    aoGet[2]:cTooltip := "Introduzca o seleccione la Fecha Final"
    aoBtn[1]:cToolTip := "Presione para Continuar"
    aoBtn[2]:cToolTip := "Presione para Salir"

  ACTIVATE DIALOG oDlg CENTERED
  *? adFechas[1], adFechas[2]
return(adFechas)

function nValorConImpuestos( pnValor, pnImpuestos )
  local nValorAntes := pnValor
  local nImpuestos := 0

  nImpuestos := pnValor * (pnImpuestos / 100)
return( pnValor + nImpuestos )

function nValorSinImpuestos( pnValor, pnImpuestos )
  local nValorAntes := pnValor
  local nImpuestos := 0

  nImpuestos := pnValor * (pnImpuestos / 100)

return( pnValor - nImpuestos )

function nImpuestosValor( pnValor, pnImpuestos )
  local nImpuestos := 0

  nImpuestos := pnValor * (pnImpuestos / 100)

return( nImpuestos )


function GetCfg( pcVariable, pcDefault )
  local xValor
  default xValor := pcDefault

  if ! file("config\cfg.dbf")
    return(xValor)
  endif

  if ! file(".\config\cfg.cdx")
    f_Indexar( "CFG", { { "VARIABLE", "VARIABLE" } }, .F., "CONFIG\" ) // Variables de Configuracion del Sistema
  endif

  if ! net_use( "cfg",,,"config\")
    dbCloseall(); return(nil)
  endif

  if cfg->(dbseek(pcVariable))
    do case
      case upper(cfg->tipo) == "C" .or. cfg->tipo == "M"
        xValor := upper(alltrim(cfg->valor))
      case upper(cfg->tipo) == "D"
        xValor := ctod(alltrim(cfg->valor))
      case upper(cfg->tipo) == "L"
        xValor := if(alltrim(cfg->valor)$"S", .T., .F.)
      case upper(cfg->tipo) == "N"
        xValor := val(cfg->valor)
    endcase
  endif

  cfg->(dbCloseArea())
return(xValor)

function lSaveCfg( pcVariable, pxValor, pcTipo )
  local xValor, lEncontrado := .F.
  default pcTipo := "C"

  if ! file(".\config\cfg.dbf")
    MsgStop("No existe el archivo de configuracion del Sistema, consulte a su asesor...", oApp:cEmpresa )
    return(nil)
  endif

  if ! file(".\config\cfg.cdx")
    f_Indexar( "CFG", { { "VARIABLE", "VARIABLE" } }, .F., "CONFIG\" ) // Variables de Configuracion del Sistema
  endif

  if ! net_use( "cfg",,,"config\")
    dbCloseall(); return(nil)
  endif

  lEncontrado := cfg->(dbseek(pcVariable))

  // hacemos la conversion de cualquier tipo de datos a caracter, porque asi es como lo almacenamos en la bd
  do case
    case upper(cfg->tipo) == "C" .or. cfg->tipo == "M"
      xValor := pxValor
    case upper(cfg->tipo) == "D"
      xValor := dtoc(pxValor)
    case upper(cfg->tipo) == "L"
      xValor := if(pxvalor, "S", "N")
    case upper(cfg->tipo) == "N"
      xValor := str(pxValor)
  endcase

  if lEncontrado .and. cfg->(rec_lock(5))
    replace cfg->valor with xValor
    cfg->(dbunlock())
  elseif cfg->(add_rec())
    replace cfg->variable with upper(pcVariable),;
            cfg->tipo     with pcTipo,;
            cfg->valor    with xValor
    cfg->(dbunlock())
  endif
  cfg->(dbCloseArea())
return( lEncontrado )



/*
function F_BUSCADATOS(pcTabla, pcEncabezado, nPicture)
  Local cId := "", cDato := "", oget := nil, osay := nil, oDlg := nil, oBtn := nil
  default pcEncabezado := "Seleccion", nPicture  := 4

  cId := space(nPicture)

  if (pcTabla)->(lastrec()) = 0
    MsgStop("No hay datos que mostrar", oApp:cEmpresa)
    return(nil)
  endif

  DEFINE DIALOG oDlg RESOURCE "DLG_BUSCAUSUARIO" FONT oApp:oMainFont TITLE pcEncabezado
     REDEFINE GET oGet VAR cId MESSAGE "Seleccione..." ID 101 OF oDlg;
                  VALID if(cId=replicate("9",nPicture), ( cDato := "Todos",;
                                         oDlg:Update(), .t. ),;
                                         EVAL( { || cId   := ValCod(cero1(cId), pcTabla) ,;
                                                    cDato := (pcTabla)->nombre, oBtn:SetFocus(), oDlg:Update(), .t. } ) ) UPDATE
     REDEFINE SAY oSay PROMPT cDato ID 201 Of oDlg COLOR CLR_RED FONT oApp:fBold UPDATE

     REDEFINE BUTTON oBtn ID 400 OF oDlg ACTION ( oDlg:End() )
     oGet:cToolTip := "Introduzca o Seleccione el Codigo"
     oBtn:cToolTip := "Presione para Continuar"
  ACTIVATE DIALOG oDlg CENTERED
return(cId)
 */



function EnDesarrollo()
return(MsgStop("En Desarrollo",oApp:cEmpresa))

FUNCTION OnInit( oDlg )
  DEFINE MESSAGE OF oDlg PROMPT "" CENTERED
RETURN NIL

********** Devuelve una matriz con elementos/renglones de nCaracteres cada uno.

FUNC GRAPPA(cCadena, nCaracteres)
LOCAL aTexto := {}
LOCAL nCont := 0
LOCAL lMuyLarga := .F.

cCadena := IF(cCadena == NIL, '', LTRIM(cCadena))
nCaracteres := IF(nCaracteres == NIL, 0, nCaracteres)

IF nCaracteres > 0
    IF LEN(cCadena) > nCaracteres
       WHILE LEN(cCadena) > 0
           WHILE chr(13)+chr(10) $ LEFT(cCadena, nCaracteres)
               IF LEFT(cCadena,2) == chr(13) + chr(10)
                   AADD(aTexto, SPACE(nCaracteres))
               ELSE
                   AADD(aTexto, PADR(LEFT(cCadena,AT(chr(13)+chr(10),cCadena)-1), nCaracteres))
               ENDIF
               cCadena := SUBSTR(cCadena, AT(chr(13)+chr(10),cCadena)+2)
           ENDDO
           IF LEN(cCadena) <= nCaracteres
               AADD(aTexto, PADR(cCadena, nCaracteres))
               EXIT
           ELSE
               IF SUBSTR(cCadena, nCaracteres, 1) == ' ' .OR. ;
                  SUBSTR(cCadena, nCaracteres+1, 1) == ' ' .OR. ;
                  SUBSTR(cCadena, nCaracteres, 1) == CHR(13) .OR. ;
                  SUBSTR(cCadena, nCaracteres+1, 1) == CHR(13)
                   *    El ltimo carcter o el primero del siguiente es justo
                   *        un espacio en blanco o un retorno de carro
                   IF SUBSTR(cCadena, nCaracteres, 1) == CHR(13)
                       AADD(aTexto, PADR(LEFT(cCadena, nCaracteres-1), nCaracteres))
                       cCadena := LTRIM(SUBSTR(cCadena, nCaracteres))
                   ELSE
                       AADD(aTexto, PADR(LEFT(cCadena, nCaracteres), nCaracteres))
                       cCadena := LTRIM(SUBSTR(cCadena, nCaracteres + 1))
                   ENDIF
               ELSE
                   nCont := nCaracteres
                   lMuyLarga := .T.
                   WHILE --nCont > 0
                       IF SUBSTR(cCadena, nCont, 1 ) == ' ' .OR. ;
                          SUBSTR(cCadena, nCont, 1 ) == CHR(13)
                           IF nCont == 1
                               IF SUBSTR(cCadena, nCont, 1) == CHR(13)
                                   AADD(aTexto, SPACE(nCaracteres))
                                   cCadena := LTRIM(SUBSTR(cCadena, 3))
                               ELSE
                                   cCadena := LTRIM(SUBSTR(cCadena, 2))
                               ENDIF
                           ELSE
                               IF SUBSTR(cCadena, nCont, 1 ) == CHR(13)
                                   AADD(aTexto, PADR(LEFT(cCadena, nCont-1), nCaracteres))
                                   cCadena := LTRIM(SUBSTR(cCadena, nCont))
                               ELSE
                                   AADD(aTexto, PADR(LEFT(cCadena, nCont), nCaracteres))
                                   cCadena := LTRIM(SUBSTR(cCadena, nCont + 1))
                               ENDIF
                               lMuyLarga := .F.
                           ENDIF
                           EXIT
                       ENDIF
                   ENDDO
                   IF lMuyLarga
                       AADD(aTexto, PADR(LEFT(cCadena, nCaracteres), nCaracteres))
                       cCadena := LTRIM(SUBSTR(cCadena, nCaracteres + 1))
                   ENDIF
               ENDIF
           ENDIF
       ENDDO
    ELSE
       AADD(aTexto, cCadena)
    ENDIF
ELSE
    AADD(aTexto, '')
ENDIF

RETURN(aTexto)

**********


function conecta( cDirWeb, lVisible, lToolBar, lStatusBar, lMenuBar )
  local Ole
  DEFAULT lVisible := .t., lToolBar:= .F., lStatusBar:= .F., lMenuBar:= .F.

   ole = TOleAuto():New("InternetExplorer.Application")
   ole:Set("Visible", lVisible)
   ole:Set("ToolBar", lToolBar)
   ole:Set("StatusBar", lStatusBar)
   ole:Set("MenuBar", lMenuBar)
   ole:Invoke("Navigate",cDirWeb)
   // ole:End()

Return Nil

FUNCTION xToc( xVar )
   DO CASE
    CASE ValType( xVar ) == "C"; RETURN xVar
    CASE ValType( xVar ) == "N"; RETURN Str( xVar )
    CASE ValType( xVar ) == "D"; RETURN dToc( xVar )
    OTHERWISE; MsgInfo( "Tipo no considerado [" + ValType( xVar ) + "]" )
   ENDCASE
RETURN ""

FUNCTION Aleatorio( nTope )
RETURN( HB_RANDOMINT( 1, nTope ) )

Function AjustaZoom( oBmp, cAccion )
local nZoom:=oBmp:Zoom()

do case
   case cAccion == "S"
       oBmp:lStretch := !oBmp:lStretch
       oBmp:ScrollAdjust()
       oBmp:Refresh( .t. )
   case cAccion == "R"
       if nZoom*10>1
          oBmp:lStretch := .f.
          nZoom:=nZoom-(0.10)
          oBmp:Zoom(nZoom)
          oBmp:Refresh()
          oBmp:ScrollAdjust()
       endif
   case cAccion == "A"
       oBmp:lStretch := .f.
       nZoom:=nZoom+0.10
       oBmp:Zoom(nZoom)
       oBmp:Refresh()
       oBmp:ScrollAdjust()
endcase
/*if oBmp:lStretch
      oSay:SetText(Oemtoansi("BITMAP ADJUST"))
else
      oSay:SetText(Oemtoansi( "ZOOM BITMAP...: "+alltrim(str(nZoom*100,10,0))+"%"))
endif*/

return NIL
